/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/accordion', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].accordion = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccordionConfig = /** @class */ (function () {
        function AccordionConfig() {
            /**
             * 是否可折叠，`false` 表示保持只有一个可折叠，`true` 表示所有都允许，默认：`false`
             */
            this.collapsible = false;
            /**
             * 自动展开第一次，默认：`true`
             */
            this.activeFirst = true;
            /**
             * 动画类型，`none` 无动画，`slide` 滑动，默认：`slide`
             */
            this.animate = 'slide';
        }
        AccordionConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ AccordionConfig.ngInjectableDef = core.defineInjectable({ factory: function AccordionConfig_Factory() { return new AccordionConfig(); }, token: AccordionConfig, providedIn: "root" });
        return AccordionConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccordionComponent = /** @class */ (function () {
        function AccordionComponent(config) {
            /**
             * 是否可折叠，`true` 表示同时所有都允许展开，`false` 表示同时只允许一个展开，默认：`false`
             */
            this.collapsible = false;
            /**
             * 自动展开第一次，默认：`true`
             */
            this.activeFirst = true;
            /**
             * 动画类型，`none` 无动画，`slide` 滑动，默认：`slide`
             */
            this._animate = 'slide';
            /**
             * 展开时回调，参数为面板下标。
             */
            this.select = new core.EventEmitter();
            this.panels = [];
            Object.assign(this, config);
        }
        /**
         * @param {?} item
         * @return {?}
         */
        AccordionComponent.prototype._add = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.panels.push(item);
            if (this.panels.length === 1 && this.activeFirst)
                item.active = true;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        AccordionComponent.prototype._remove = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.panels.splice(this.panels.indexOf(item), 1);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        AccordionComponent.prototype._index = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return this.panels.indexOf(item);
        };
        /**
         * @param {?} cur
         * @return {?}
         */
        AccordionComponent.prototype._closeOthers = /**
         * @param {?} cur
         * @return {?}
         */
        function (cur) {
            if (this.collapsible)
                return;
            this.panels.forEach((/**
             * @param {?} panel
             * @return {?}
             */
            function (panel) {
                if (!panel.disabled && panel !== cur)
                    panel.active = false;
            }));
        };
        AccordionComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-accordion',
                        exportAs: 'weuiAccordion',
                        template: "\n    <ng-content></ng-content>\n  ",
                        host: {
                            '[attr.aria-multiselectable]': 'closeOthers',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        AccordionComponent.ctorParameters = function () { return [
            { type: AccordionConfig }
        ]; };
        AccordionComponent.propDecorators = {
            collapsible: [{ type: core.Input }],
            activeFirst: [{ type: core.Input }],
            _animate: [{ type: core.Input }],
            select: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], AccordionComponent.prototype, "collapsible", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], AccordionComponent.prototype, "activeFirst", void 0);
        return AccordionComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccordionPanelComponent = /** @class */ (function () {
        function AccordionPanelComponent(accordion) {
            this.accordion = accordion;
            /**
             * 是否禁止
             */
            this.disabled = false;
            this._active = false;
        }
        Object.defineProperty(AccordionPanelComponent.prototype, "active", {
            /**
             * 是否展开
             */
            get: /**
             * 是否展开
             * @return {?}
             */
            function () {
                return this._active;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._active = value;
                if (value)
                    this.accordion._closeOthers(this);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        AccordionPanelComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.accordion._add(this);
        };
        /**
         * @return {?}
         */
        AccordionPanelComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.accordion._remove(this);
        };
        /**
         * @return {?}
         */
        AccordionPanelComponent.prototype._toggle = /**
         * @return {?}
         */
        function () {
            if (!this.disabled) {
                this.active = !this.active;
                this.accordion.select.emit(this.accordion._index(this));
            }
        };
        AccordionPanelComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-accordion-panel',
                        exportAs: 'weuiAccordionPanel',
                        template: "\n    <div role=\"tab\" (click)=\"_toggle()\"><ng-content select=\"[heading]\"></ng-content></div>\n    <div role=\"tabpanel\" class=\"weui-accordion-content\"><ng-content></ng-content></div>\n  ",
                        host: {
                            '[class.weui-accordion-panel-disabled]': 'disabled',
                            '[class.weui-accordion-active]': 'active',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        AccordionPanelComponent.ctorParameters = function () { return [
            { type: AccordionComponent, decorators: [{ type: core.Inject, args: [AccordionComponent,] }] }
        ]; };
        AccordionPanelComponent.propDecorators = {
            disabled: [{ type: core.Input }],
            active: [{ type: core.Input }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], AccordionPanelComponent.prototype, "disabled", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [Boolean])
        ], AccordionPanelComponent.prototype, "active", null);
        return AccordionPanelComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccordionModule = /** @class */ (function () {
        function AccordionModule() {
        }
        AccordionModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [AccordionPanelComponent, AccordionComponent],
                        exports: [AccordionPanelComponent, AccordionComponent],
                    },] }
        ];
        return AccordionModule;
    }());

    exports.AccordionComponent = AccordionComponent;
    exports.AccordionConfig = AccordionConfig;
    exports.AccordionModule = AccordionModule;
    exports.AccordionPanelComponent = AccordionPanelComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-accordion.umd.js.map
