/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('ngx-weui/core'), require('@angular/animations'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/actionsheet', ['exports', '@angular/common', '@angular/core', 'ngx-weui/core', '@angular/animations', 'rxjs'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].actionsheet = {}), global.ng.common, global.ng.core, global['ngx-weui'].core, global.ng.animations, global.rxjs));
}(this, function (exports, common, core, core$1, animations, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetConfig = /** @class */ (function () {
        function ActionSheetConfig() {
            /**
             * 样式，默认：`ios`
             */
            this.skin = 'ios';
            /**
             * 取消文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        ActionSheetConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ ActionSheetConfig.ngInjectableDef = core.defineInjectable({ factory: function ActionSheetConfig_Factory() { return new ActionSheetConfig(); }, token: ActionSheetConfig, providedIn: "root" });
        return ActionSheetConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetComponent = /** @class */ (function () {
        function ActionSheetComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            this.destroied = false;
            this._shown = false;
            /**
             * 动画状态码
             */
            this._shownAnt = false;
            /**
             * 菜单内容
             */
            this.menus = [];
            /**
             * 关闭回调
             */
            this.close = new core.EventEmitter();
        }
        Object.defineProperty(ActionSheetComponent.prototype, "_visibility", {
            get: /**
             * @return {?}
             */
            function () {
                return this._shownAnt ? 'show' : 'hide';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        ActionSheetComponent.prototype.detectChanges = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.destroied)
                return;
            this.cdr.detectChanges();
        };
        /**
         * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
         */
        /**
         * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
         * @return {?}
         */
        ActionSheetComponent.prototype.show = /**
         * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
         * @return {?}
         */
        function () {
            var _this = this;
            this.config = __assign({ backdrop: true, skin: 'auto' }, this.DEF, this.config);
            if (this.config.skin === 'auto') {
                this.config.skin = core$1.isAndroid() ? 'android' : 'ios';
            }
            this._shown = true;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._shownAnt = true;
                _this.detectChanges();
            }), 10);
            return rxjs.Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param is_backdrop 是否从背景上点击
         */
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否从背景上点击
         * @return {?}
         */
        ActionSheetComponent.prototype.hide = /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否从背景上点击
         * @return {?}
         */
        function (is_backdrop) {
            var _this = this;
            if (is_backdrop === true && this.config.backdrop === false)
                return false;
            this._shownAnt = false;
            this.detectChanges();
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._shown = false;
                _this.close.emit();
            }), this.config.skin === 'android' ? 200 : 300);
        };
        /**
         * 选择动作
         */
        /**
         * 选择动作
         * @param {?} menu
         * @return {?}
         */
        ActionSheetComponent.prototype._onSelect = /**
         * 选择动作
         * @param {?} menu
         * @return {?}
         */
        function (menu) {
            this.observer.next(menu);
            this.observer.complete();
            this.hide();
        };
        /**
         * @return {?}
         */
        ActionSheetComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.destroied = true;
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                ((/** @type {?} */ (this.observer))).unsubscribe();
            }
        };
        ActionSheetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-actionsheet',
                        exportAs: 'weuiActionsheet',
                        template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-actionsheet\" [ngClass]=\"{ 'weui-actionsheet_toggle': _shownAnt && config.skin === 'ios' }\">\n  <div class=\"weui-actionsheet__title\" *ngIf=\"config.skin === 'ios' && config.title\">\n    <p class=\"weui-actionsheet__title-text\">{{ config.title }}</p>\n  </div>\n  <div class=\"weui-actionsheet__menu\">\n    <div class=\"weui-actionsheet__cell\" *ngFor=\"let item of menus\" (click)=\"_onSelect(item)\">{{ item.text }}</div>\n  </div>\n  <div class=\"weui-actionsheet__action\" *ngIf=\"config.skin === 'ios' && config.cancel\">\n    <div class=\"weui-actionsheet__cell\" (click)=\"hide()\">{{ config.cancel }}</div>\n  </div>\n</div>\n",
                        animations: [
                            animations.trigger('visibility', [
                                animations.state('show', animations.style({ opacity: 1 })),
                                animations.state('hide', animations.style({ opacity: 0 })),
                                animations.transition('hide <=> show', [animations.animate(200)]),
                            ]),
                        ],
                        host: {
                            '[hidden]': '!_shown',
                            '[class.weui-skin_android]': 'config.skin === "android"',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ActionSheetComponent.ctorParameters = function () { return [
            { type: ActionSheetConfig },
            { type: core.ChangeDetectorRef }
        ]; };
        ActionSheetComponent.propDecorators = {
            config: [{ type: core.Input }],
            menus: [{ type: core.Input }],
            close: [{ type: core.Output }]
        };
        return ActionSheetComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetService = /** @class */ (function (_super) {
        __extends(ActionSheetService, _super);
        function ActionSheetService(resolver, applicationRef, injector, doc) {
            return _super.call(this, resolver, applicationRef, injector, doc) || this;
        }
        /**
         * 创建一个弹出式菜单并显示
         *
         * @param menus 菜单内容
         * @param config 配置性（可选）
         * @returns 可订阅来获取结果
         */
        /**
         * 创建一个弹出式菜单并显示
         *
         * @param {?} menus 菜单内容
         * @param {?=} config 配置性（可选）
         * @return {?} 可订阅来获取结果
         */
        ActionSheetService.prototype.show = /**
         * 创建一个弹出式菜单并显示
         *
         * @param {?} menus 菜单内容
         * @param {?=} config 配置性（可选）
         * @return {?} 可订阅来获取结果
         */
        function (menus, config) {
            var _this = this;
            if (config === void 0) { config = {}; }
            /** @type {?} */
            var componentRef = this.build(ActionSheetComponent);
            componentRef.instance.menus = menus;
            if (config)
                componentRef.instance.config = config;
            componentRef.instance.close.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            return componentRef.instance.show();
        };
        ActionSheetService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        ActionSheetService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        /** @nocollapse */ ActionSheetService.ngInjectableDef = core.defineInjectable({ factory: function ActionSheetService_Factory() { return new ActionSheetService(core.inject(core.ComponentFactoryResolver), core.inject(core.ApplicationRef), core.inject(core.INJECTOR), core.inject(common.DOCUMENT)); }, token: ActionSheetService, providedIn: "root" });
        return ActionSheetService;
    }(core$1.BaseService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetModule = /** @class */ (function () {
        function ActionSheetModule() {
        }
        ActionSheetModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ActionSheetComponent],
                        exports: [ActionSheetComponent],
                        entryComponents: [ActionSheetComponent],
                    },] }
        ];
        return ActionSheetModule;
    }());

    exports.ActionSheetComponent = ActionSheetComponent;
    exports.ActionSheetConfig = ActionSheetConfig;
    exports.ActionSheetModule = ActionSheetModule;
    exports.ActionSheetService = ActionSheetService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-actionsheet.umd.js.map
