/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/button', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].button = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonConfig = /** @class */ (function () {
        function ButtonConfig() {
            /**
             * 操作场景：primary、default、warn
             */
            this.type = 'primary';
            /**
             * disabled状态，默认：`false`
             */
            this.disabled = false;
            /**
             * 是否加载状态，默认：`false`
             */
            this.loading = false;
            /**
             * 镂空按钮，默认：`false`
             */
            this.plain = false;
            /**
             * 是否小号，默认：`false`
             */
            this.mini = false;
        }
        ButtonConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ ButtonConfig.ngInjectableDef = core.defineInjectable({ factory: function ButtonConfig_Factory() { return new ButtonConfig(); }, token: ButtonConfig, providedIn: "root" });
        return ButtonConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonComponent = /** @class */ (function () {
        function ButtonComponent(_config, el, uhcs) {
            this.el = el;
            this.uhcs = uhcs;
            /**
             * 操作场景：primary、default、warn，默认：`primary`
             */
            this.type = 'primary';
            /**
             * 是否加载状态
             */
            this.loading = false;
            /**
             * 是否小号
             */
            this.mini = false;
            /**
             * 镂空按钮
             */
            this.plain = false;
            /**
             * 行按钮
             */
            this.cell = false;
            /**
             * Block 按钮
             */
            this.block = false;
            /**
             * 禁用状态
             */
            this.disabled = false;
            Object.assign(this, _config);
        }
        /**
         * @private
         * @return {?}
         */
        ButtonComponent.prototype.setClassMap = /**
         * @private
         * @return {?}
         */
        function () {
            var _a;
            /** @type {?} */
            var prefixCls = 'weui-btn';
            var _b = this, uhcs = _b.uhcs, el = _b.el, type = _b.type, plain = _b.plain, cell = _b.cell, disabled = _b.disabled, block = _b.block, mini = _b.mini, loading = _b.loading;
            /** @type {?} */
            var median = plain ? 'plain' : cell ? 'cell' : '';
            uhcs.updateHostClass(el.nativeElement, (_a = {},
                _a["" + prefixCls] = !cell,
                _a[prefixCls + "_cell"] = cell,
                _a[prefixCls + "_disabled"] = !plain && disabled,
                _a[prefixCls + "_block"] = block,
                _a[prefixCls + "_mini"] = mini,
                _a[prefixCls + "_" + median + "-" + type] = median,
                _a[prefixCls + "_" + type] = !median,
                _a[prefixCls + "_loading"] = loading,
                _a[prefixCls + "_plain-disabled"] = plain && disabled,
                _a));
        };
        /**
         * @return {?}
         */
        ButtonComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.setClassMap();
        };
        /**
         * @return {?}
         */
        ButtonComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this.setClassMap();
        };
        ButtonComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-button, [weui-button]',
                        exportAs: 'weuiButton',
                        host: {
                            '[attr.disabled]': 'disabled ? "disabled" : null',
                        },
                        template: '<i class="weui-loading" *ngIf="loading"></i><ng-content></ng-content>',
                        providers: [core$1.UpdateHostClassService],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ButtonComponent.ctorParameters = function () { return [
            { type: ButtonConfig },
            { type: core.ElementRef },
            { type: core$1.UpdateHostClassService }
        ]; };
        ButtonComponent.propDecorators = {
            type: [{ type: core.Input, args: ['weui-type',] }],
            loading: [{ type: core.Input, args: ['weui-loading',] }],
            mini: [{ type: core.Input, args: ['weui-mini',] }],
            plain: [{ type: core.Input, args: ['weui-plain',] }],
            cell: [{ type: core.Input, args: ['weui-cell',] }],
            block: [{ type: core.Input, args: ['weui-block',] }],
            disabled: [{ type: core.Input }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "loading", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "mini", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "plain", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "cell", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "block", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "disabled", void 0);
        return ButtonComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonIconComponent = /** @class */ (function () {
        function ButtonIconComponent() {
        }
        ButtonIconComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-button-icon, [weui-button-icon]',
                        exportAs: 'weuiButtonIcon',
                        host: {
                            '[class.weui-btn_cell__icon]': 'true',
                        },
                        template: '<ng-content></ng-content>',
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        return ButtonIconComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonModule = /** @class */ (function () {
        function ButtonModule() {
        }
        ButtonModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ButtonComponent, ButtonIconComponent],
                        exports: [ButtonComponent, ButtonIconComponent],
                    },] }
        ];
        return ButtonModule;
    }());

    exports.ButtonComponent = ButtonComponent;
    exports.ButtonConfig = ButtonConfig;
    exports.ButtonIconComponent = ButtonIconComponent;
    exports.ButtonModule = ButtonModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-button.umd.js.map
