/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/cell', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].cell = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 单元格滑块
     */
    var SwipeDirective = /** @class */ (function () {
        function SwipeDirective(el) {
            this.el = el;
            this.curX = 0;
            this.opend = false;
            /**
             * 右边滑动宽度（单位：px），默认：`68`
             */
            this.width = 68;
        }
        /**
         * @return {?}
         */
        SwipeDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var el = this.el.nativeElement;
            this.swipeEl = el.querySelector('.weui-cell__bd');
            if (!this.swipeEl)
                this.width = 0;
            else {
                this.setPos(0);
                this.swipeEl.style.transition = 'transform .3s';
            }
        };
        /**
         * @private
         * @param {?} x
         * @return {?}
         */
        SwipeDirective.prototype.setPos = /**
         * @private
         * @param {?} x
         * @return {?}
         */
        function (x) {
            this.swipeEl.style.transform = "translateX(-" + x + "px)";
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        SwipeDirective.prototype.onTouchStart = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            this.curX = ($event.touches[0] || $event.changedTouches[0]).pageX;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        SwipeDirective.prototype.onTouchMove = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var touch = $event.touches[0] || $event.changedTouches[0];
            /** @type {?} */
            var newX = this.curX - touch.pageX;
            if (this.opend) {
                newX = newX > 0 ? this.width : this.width - Math.abs(newX);
            }
            else {
                newX = newX > this.width ? this.width : newX;
            }
            this.setPos(newX <= 0 ? 0 : newX);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        SwipeDirective.prototype.onTouchEnd = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var touch = $event.touches[0] || $event.changedTouches[0];
            /** @type {?} */
            var newX = Math.abs(this.curX - touch.pageX);
            if (newX === 0)
                return;
            if (this.opend)
                newX = this.width - newX;
            // 当移动超过一半都视为打开
            if (newX > 0 && newX > +this.width / 2) {
                this.opend = true;
                this.setPos(this.width);
            }
            else {
                this.opend = false;
                this.setPos(0);
            }
        };
        SwipeDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-swipe]',
                        exportAs: 'weuiSwipe',
                    },] }
        ];
        /** @nocollapse */
        SwipeDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        SwipeDirective.propDecorators = {
            width: [{ type: core.Input, args: ['weui-width',] }],
            onTouchStart: [{ type: core.HostListener, args: ['touchstart', ['$event'],] }],
            onTouchMove: [{ type: core.HostListener, args: ['touchmove', ['$event'],] }],
            onTouchEnd: [{ type: core.HostListener, args: ['touchend', ['$event'],] }, { type: core.HostListener, args: ['touchcancel', ['$event'],] }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], SwipeDirective.prototype, "width", void 0);
        return SwipeDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CellModule = /** @class */ (function () {
        function CellModule() {
        }
        CellModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [SwipeDirective],
                        exports: [SwipeDirective],
                    },] }
        ];
        return CellModule;
    }());

    exports.CellModule = CellModule;
    exports.SwipeDirective = SwipeDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-cell.umd.js.map
