/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/core', ['exports', '@angular/common', '@angular/core', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].core = {}), global.ng.common, global.ng.core, global.ng.platformBrowser));
}(this, function (exports, common, core, platformBrowser) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoaderService = /** @class */ (function () {
        function LoaderService(doc) {
            this.doc = doc;
            this.list = {};
        }
        /**
         * @param {?} paths
         * @return {?}
         */
        LoaderService.prototype.load = /**
         * @param {?} paths
         * @return {?}
         */
        function (paths) {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                /** @type {?} */
                var promises = [];
                if (!Array.isArray(paths))
                    paths = [paths];
                ((/** @type {?} */ (paths))).forEach((/**
                 * @param {?} path
                 * @return {?}
                 */
                function (path) {
                    if (path.endsWith('.css')) {
                        promises.push(_this.loadCss(path));
                    }
                    else {
                        promises.push(_this.loadScript(path));
                    }
                }));
                Promise.all(promises)
                    .then((/**
                 * @return {?}
                 */
                function () { return resolve(true); }))
                    .catch((/**
                 * @return {?}
                 */
                function () { return resolve(false); }));
            }));
        };
        /**
         * @param {?} path
         * @return {?}
         */
        LoaderService.prototype.loadScript = /**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                if (_this.list[path] === true) {
                    resolve((/** @type {?} */ ({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                    return;
                }
                _this.list[path] = true;
                /** @type {?} */
                var node = _this.doc.createElement('script');
                node.type = 'text/javascript';
                node.src = path;
                node.charset = 'utf-8';
                node.defer = true;
                node.onload = (/**
                 * @return {?}
                 */
                function () {
                    resolve((/** @type {?} */ ({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                });
                node.onerror = (/**
                 * @return {?}
                 */
                function () {
                    return resolve((/** @type {?} */ ({
                        path: path,
                        loaded: false,
                        status: 'Loaded',
                    })));
                });
                _this.doc.getElementsByTagName('head')[0].appendChild(node);
            }));
        };
        /**
         * @param {?} path
         * @return {?}
         */
        LoaderService.prototype.loadCss = /**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                if (_this.list[path] === true) {
                    resolve((/** @type {?} */ ({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                    return;
                }
                _this.list[path] = true;
                /** @type {?} */
                var node = _this.doc.createElement('link');
                node.rel = 'stylesheet';
                node.type = 'text/css';
                node.href = path;
                _this.doc.getElementsByTagName('head')[0].appendChild(node);
                resolve((/** @type {?} */ ({
                    path: path,
                    loaded: true,
                    status: 'Loaded',
                })));
            }));
        };
        LoaderService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        LoaderService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        /** @nocollapse */ LoaderService.ngInjectableDef = core.defineInjectable({ factory: function LoaderService_Factory() { return new LoaderService(core.inject(common.DOCUMENT)); }, token: LoaderService, providedIn: "root" });
        return LoaderService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var BaseService = /** @class */ (function () {
        function BaseService(resolver, applicationRef, injector, doc) {
            this.resolver = resolver;
            this.applicationRef = applicationRef;
            this.injector = injector;
            this.doc = doc;
            this.list = [];
        }
        /**
         * 销毁
         *
         * @param component 下标（从0开始或组件引用对象），或不指定时，销毁最新一个
         */
        /**
         * 销毁
         *
         * @param {?=} component 下标（从0开始或组件引用对象），或不指定时，销毁最新一个
         * @return {?}
         */
        BaseService.prototype.destroy = /**
         * 销毁
         *
         * @param {?=} component 下标（从0开始或组件引用对象），或不指定时，销毁最新一个
         * @return {?}
         */
        function (component) {
            if (typeof component === 'number')
                component = this.list[(/** @type {?} */ (component))];
            if (!component)
                component = this.list.pop();
            if (component)
                ((/** @type {?} */ (component))).destroy();
        };
        /**
         * 销毁所有
         */
        /**
         * 销毁所有
         * @return {?}
         */
        BaseService.prototype.destroyAll = /**
         * 销毁所有
         * @return {?}
         */
        function () {
            var e_1, _a;
            try {
                for (var _b = __values(this.list), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var component = _c.value;
                    this.destroy(component);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        /** 动态构建组件 */
        /**
         * 动态构建组件
         * @protected
         * @template T
         * @param {?} component
         * @return {?}
         */
        BaseService.prototype.build = /**
         * 动态构建组件
         * @protected
         * @template T
         * @param {?} component
         * @return {?}
         */
        function (component) {
            var _this = this;
            /** @type {?} */
            var componentFactory = this.resolver.resolveComponentFactory(component);
            /** @type {?} */
            var componentRef = componentFactory.create(this.injector);
            this.list.push(componentRef);
            /** @type {?} */
            var componentRootNode = (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
            this.applicationRef.attachView(componentRef.hostView);
            componentRef.onDestroy((/**
             * @return {?}
             */
            function () {
                _this.applicationRef.detachView(componentRef.hostView);
            }));
            this.doc.body.appendChild(componentRootNode);
            return componentRef;
        };
        /** @nocollapse */
        BaseService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        return BaseService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 向上查找父节点
     * @param {?} el
     * @param {?} selector
     * @return {?}
     */
    function findParent(el, selector) {
        /** @type {?} */
        var retEl = null;
        while (el) {
            if (el.matches(selector)) {
                retEl = el;
                break;
            }
            el = el.parentElement;
        }
        return retEl;
    }
    /**
     * 查找并创建
     * @param {?} el
     * @param {?=} selector
     * @param {?=} tagName
     * @param {?=} className
     * @param {?=} cssText
     * @return {?}
     */
    function add(el, selector, tagName, className, cssText) {
        if (selector === void 0) { selector = '.weui-cell__ft'; }
        if (tagName === void 0) { tagName = 'div'; }
        if (className === void 0) { className = 'weui-cell__ft'; }
        if (cssText === void 0) { cssText = ''; }
        /** @type {?} */
        var ret = el.querySelector(selector);
        if (!ret) {
            ret = document.createElement(tagName);
            ret.className = className;
            if (cssText)
                ret.style.cssText = cssText;
            el.appendChild(ret);
        }
        return ret;
    }
    /**
     * 移除
     * @param {?} el
     * @param {?} selector
     * @return {?}
     */
    function remove(el, selector) {
        if (!el)
            return;
        /** @type {?} */
        var ret = el.querySelector(selector);
        if (ret) {
            el.removeChild(ret);
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 检查是否安卓系统
     * @return {?}
     */
    function isAndroid() {
        return /android (\d+)/.test(platformBrowser.ɵgetDOM()
            .getUserAgent()
            .toLowerCase());
    }
    /**
     * 检查是否IOS系统
     * @return {?}
     */
    function isIOS() {
        return /iPad|iPhone|iPod/.test(platformBrowser.ɵgetDOM().getUserAgent());
    }
    /**
     * 检查File是否为图像文件
     * @param {?} file
     * @return {?}
     */
    function isImage(file) {
        if (!(file instanceof window.File))
            return false;
        /** @type {?} */
        var type = "|" + file.type.slice(file.type.lastIndexOf('/') + 1) + "|";
        return '|jpg|png|jpeg|bmp|gif|'.indexOf(type) !== -1;
    }
    /**
     * 生成可预览的图像地址
     * @param {?} file
     * @return {?}
     */
    function genImageUrl(file) {
        if (isImage(file))
            return window.URL.createObjectURL(file);
        return '';
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function isEmpty(element) {
        /** @type {?} */
        var nodes = element.childNodes;
        for (var i = 0; i < nodes.length; i++) {
            /** @type {?} */
            var node = nodes.item(i);
            if (node.nodeType === 1 && ((/** @type {?} */ (node))).outerHTML.toString().trim().length !== 0) {
                return false;
            }
            else if (node.nodeType === 3 && (/** @type {?} */ (node.textContent)).toString().trim().length !== 0) {
                return false;
            }
        }
        return true;
    }
    /**
     * @param {?} value
     * @param {?=} allowUndefined
     * @return {?}
     */
    function toBoolean(value, allowUndefined) {
        if (allowUndefined === void 0) { allowUndefined = false; }
        return allowUndefined && typeof value === 'undefined' ? undefined : value != null && "" + value !== 'false';
    }
    /**
     * Input decorator that handle a prop to do get/set automatically with toBoolean
     * \@example
     * ```typescript
     * \@Input() \@InputBoolean() visible: boolean = false; / \@InputBoolean(null) visible: boolean = false;
     * ```
     * @param {?=} allowUndefined
     * @return {?}
     */
    function InputBoolean(allowUndefined) {
        if (allowUndefined === void 0) { allowUndefined = false; }
        return (/**
         * @param {?} target
         * @param {?} name
         * @return {?}
         */
        function InputBooleanPropDecorator(target, name) {
            // Add our own private prop
            /** @type {?} */
            var privatePropName = "$$__" + name;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by InputBoolean decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true,
            });
            Object.defineProperty(target, name, {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this[privatePropName]; // tslint:disable-line:no-invalid-this
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this[privatePropName] = toBoolean(value, allowUndefined); // tslint:disable-line:no-invalid-this
                },
            });
        });
    }
    /**
     * @param {?} value
     * @param {?=} fallbackValue
     * @return {?}
     */
    function toNumber(value, fallbackValue) {
        if (fallbackValue === void 0) { fallbackValue = 0; }
        return !isNaN(parseFloat((/** @type {?} */ (value)))) && !isNaN(Number(value)) ? Number(value) : fallbackValue;
    }
    /**
     * Input decorator that handle a prop to do get/set automatically with toNumber
     * \@example
     * ```typescript
     * \@Input() \@InputNumber() visible: number = 1; / \@InputNumber(null) visible: number = 2;
     * ```
     * @param {?=} fallback
     * @return {?}
     */
    function InputNumber(fallback) {
        if (fallback === void 0) { fallback = 0; }
        return (/**
         * @param {?} target
         * @param {?} name
         * @return {?}
         */
        function InputBooleanPropDecorator(target, name) {
            // Add our own private prop
            /** @type {?} */
            var privatePropName = "$$__" + name;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by InputNumber decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true,
            });
            Object.defineProperty(target, name, {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this[privatePropName]; // tslint:disable-line:no-invalid-this
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this[privatePropName] = toNumber(value, fallback); // tslint:disable-line:no-invalid-this
                },
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StringTemplateOutletDirective = /** @class */ (function () {
        function StringTemplateOutletDirective(viewContainer, defaultTemplate) {
            this.viewContainer = viewContainer;
            this.defaultTemplate = defaultTemplate;
            this.inputTemplate = null;
            this.inputViewRef = null;
            this.defaultViewRef = null;
        }
        Object.defineProperty(StringTemplateOutletDirective.prototype, "stringTemplateOutlet", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value instanceof core.TemplateRef) {
                    this.isTemplate = true;
                    this.inputTemplate = value;
                }
                else {
                    this.isTemplate = false;
                }
                this.updateView();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        StringTemplateOutletDirective.prototype.updateView = /**
         * @return {?}
         */
        function () {
            if (!this.isTemplate) {
                /** use default template when input is string **/
                if (!this.defaultViewRef) {
                    this.viewContainer.clear();
                    this.inputViewRef = null;
                    if (this.defaultTemplate) {
                        this.defaultViewRef = this.viewContainer.createEmbeddedView(this.defaultTemplate);
                    }
                }
            }
            else {
                /** use input template when input is templateRef **/
                if (!this.inputViewRef) {
                    this.viewContainer.clear();
                    this.defaultViewRef = null;
                    if (this.inputTemplate) {
                        this.inputViewRef = this.viewContainer.createEmbeddedView(this.inputTemplate);
                    }
                }
            }
        };
        StringTemplateOutletDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[stringTemplateOutlet]',
                        exportAs: 'stringTemplateOutlet',
                    },] }
        ];
        /** @nocollapse */
        StringTemplateOutletDirective.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: core.TemplateRef }
        ]; };
        StringTemplateOutletDirective.propDecorators = {
            stringTemplateOutlet: [{ type: core.Input }]
        };
        return StringTemplateOutletDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddOnModule = /** @class */ (function () {
        function AddOnModule() {
        }
        AddOnModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [StringTemplateOutletDirective],
                        declarations: [StringTemplateOutletDirective],
                    },] }
        ];
        return AddOnModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UpdateHostClassService = /** @class */ (function () {
        function UpdateHostClassService(rendererFactory2) {
            this.classMap = {};
            this.renderer = rendererFactory2.createRenderer(null, null);
        }
        /**
         * @param {?} el
         * @param {?} classMap
         * @return {?}
         */
        UpdateHostClassService.prototype.updateHostClass = /**
         * @param {?} el
         * @param {?} classMap
         * @return {?}
         */
        function (el, classMap) {
            this.removeClass(el, this.classMap, this.renderer);
            this.classMap = __assign({}, classMap);
            this.addClass(el, this.classMap, this.renderer);
        };
        /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        UpdateHostClassService.prototype.removeClass = /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        function (el, classMap, renderer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i)) {
                    renderer.removeClass(el, i);
                }
            }
        };
        /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        UpdateHostClassService.prototype.addClass = /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        function (el, classMap, renderer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i) && classMap[i]) {
                    renderer.addClass(el, i);
                }
            }
        };
        UpdateHostClassService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        UpdateHostClassService.ctorParameters = function () { return [
            { type: core.RendererFactory2 }
        ]; };
        return UpdateHostClassService;
    }());

    exports.AddOnModule = AddOnModule;
    exports.BaseService = BaseService;
    exports.InputBoolean = InputBoolean;
    exports.InputNumber = InputNumber;
    exports.LoaderService = LoaderService;
    exports.StringTemplateOutletDirective = StringTemplateOutletDirective;
    exports.UpdateHostClassService = UpdateHostClassService;
    exports.add = add;
    exports.findParent = findParent;
    exports.genImageUrl = genImageUrl;
    exports.isAndroid = isAndroid;
    exports.isEmpty = isEmpty;
    exports.isIOS = isIOS;
    exports.isImage = isImage;
    exports.remove = remove;
    exports.toBoolean = toBoolean;
    exports.toNumber = toNumber;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-core.umd.js.map
