/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/form', ['exports', '@angular/core', '@angular/forms', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].form = {}), global.ng.core, global.ng.forms, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, forms, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文本框，指令是对文本框格式校验（邮箱、手机、身份证等）、视觉效果的增强而已
     */
    var InputDirective = /** @class */ (function () {
        function InputDirective(el) {
            this.el = el;
            /**
             * 是否必填项，**等同于** <intpu required> 的值，当值必填时会有视觉效果
             */
            this.required = 'warn';
            /**
             * 是否自动清除内容中的空格
             */
            this.cleaner = false;
        }
        /**
         * @return {?}
         */
        InputDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.parentEl = core$1.findParent(this.el.nativeElement, '.weui-cell');
            if (!this.parentEl) {
                console.error('父DOM结构至少必须包含一个.weui-cell');
                return;
            }
            // 检查是否有 weui-cell__ft
            this.ftEl = core$1.add(this.parentEl);
        };
        /**
         * @return {?}
         */
        InputDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this._createValidator();
            if (this._onChange)
                this._onChange();
        };
        /**
         * @private
         * @return {?}
         */
        InputDirective.prototype._createValidator = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var regex = null;
            if (this.inputRegex) {
                if (typeof this.inputRegex === 'string') {
                    regex = new RegExp("^" + this.inputRegex + "$");
                }
                else {
                    regex = this.inputRegex;
                }
            }
            else {
                // 默认行为
                if (this.inputType) {
                    switch (this.inputType) {
                        case 'qq':
                        case 'number':
                            regex = /^[0-9]+$/;
                            break;
                        case 'digit':
                            regex = /^[.0-9]+$/;
                            break;
                        case 'tel':
                            regex = /^[-.0-9]+$/;
                            break;
                        case 'email':
                            regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                            this.cleaner = true;
                            break;
                        case 'mobile':
                            regex = /^1[0-9]{10}$/;
                            this.cleaner = true;
                            break;
                        case 'idcard': // 身份证
                            regex = /^[X0-9]{15,18}$/;
                            this.cleaner = true;
                            break;
                    }
                }
            }
            this._validator = (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var value = control.value;
                if (value == null || value.length === 0) {
                    if (_this.required !== undefined)
                        return { icon: _this.required, type: 'required', actualValue: value };
                    return null;
                }
                if (_this.cleaner && value.includes(' ')) {
                    value = value.replace(/ /g, '');
                    control.setValue(value, { emitEvent: false });
                }
                return regex === null || regex.test(value) ? null : { icon: 'warn', type: 'regex', actualValue: value };
            });
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        InputDirective.prototype.registerOnValidatorChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} c
         * @return {?}
         */
        InputDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (!this.parentEl)
                return null;
            /** @type {?} */
            var ret = this._validator(c);
            if (ret === null) {
                this.parentEl.classList.remove('weui-cell_warn');
                core$1.remove(this.ftEl, 'i');
            }
            else {
                core$1.remove(this.ftEl, 'i');
                this.parentEl.classList.add('weui-cell_warn');
                /** @type {?} */
                var icon = "weui-icon-" + ret.icon;
                core$1.add(this.ftEl, '.' + icon, 'i', icon);
            }
            return ret;
        };
        InputDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-input]',
                        exportAs: 'weuiInput',
                        providers: [
                            {
                                provide: forms.NG_VALIDATORS,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return InputDirective; })),
                                multi: true,
                            },
                        ],
                    },] }
        ];
        /** @nocollapse */
        InputDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        InputDirective.propDecorators = {
            inputType: [{ type: core.Input, args: ['weui-input',] }],
            inputRegex: [{ type: core.Input, args: ['weui-regex',] }],
            required: [{ type: core.Input, args: ['weui-required',] }],
            cleaner: [{ type: core.Input, args: ['weui-cleaner',] }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], InputDirective.prototype, "cleaner", void 0);
        return InputDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChecklistDirective = /** @class */ (function () {
        function ChecklistDirective() {
            this.checked = false;
        }
        Object.defineProperty(ChecklistDirective.prototype, "value", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._value = val;
                this.checked = this.targetArray.indexOf(val) !== -1;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} $event
         * @return {?}
         */
        ChecklistDirective.prototype._change = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if ($event.target.checked) {
                this.targetArray.push(this._value);
            }
            else {
                this.targetArray.splice(this.targetArray.indexOf(this._value), 1);
            }
        };
        ChecklistDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-checklist]',
                        exportAs: 'weuiChecklist',
                        host: {
                            '(change)': '_change($event)',
                            '[checked]': 'checked',
                        },
                    },] }
        ];
        ChecklistDirective.propDecorators = {
            targetArray: [{ type: core.Input, args: ['weui-checklist',] }],
            value: [{ type: core.Input, args: ['weui-value',] }]
        };
        return ChecklistDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 获取验证码
     */
    var VCodeDirective = /** @class */ (function () {
        function VCodeDirective(el) {
            this.el = el;
            /**
             * 时长（单位：秒），默认：`60`
             */
            this.seconds = 60;
            /**
             * 倒计时模板，使用 `${num}` 表示当前秒数
             */
            // tslint:disable-next-line: no-invalid-template-strings
            this.tpl = '${num} 秒';
            /**
             * 重新发送提醒文本
             */
            this.error = '重新发送';
            this._disabled = false;
        }
        /**
         * @return {?}
         */
        VCodeDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (typeof this.onSend !== 'function')
                console.error('weui-vcode必须传递一个返回值为 `Observable<boolean>` 函数');
            this._cur = this.el.nativeElement.innerHTML;
        };
        /**
         * @return {?}
         */
        VCodeDirective.prototype._onClick = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._disabled = true;
            this.onSend().subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                res ? _this.tick() : _this.err();
            }));
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.err = /**
         * @private
         * @return {?}
         */
        function () {
            this._disabled = false;
            this.el.nativeElement.innerHTML = this.error;
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.tick = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var count = this.seconds < 1 ? 1 : this.seconds;
            this.setText(count);
            this._t = setInterval((/**
             * @return {?}
             */
            function () {
                if (--count <= 0) {
                    _this._disabled = false;
                    _this.el.nativeElement.innerHTML = _this._cur;
                    _this.destroy();
                }
                else
                    _this.setText(count);
            }), 1000);
        };
        /**
         * @private
         * @param {?} num
         * @return {?}
         */
        VCodeDirective.prototype.setText = /**
         * @private
         * @param {?} num
         * @return {?}
         */
        function (num) {
            this.el.nativeElement.innerHTML = this.tpl.replace(/\${num}/, num.toString());
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.destroy = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._t) {
                clearInterval(this._t);
                this._t = null;
            }
        };
        /**
         * @return {?}
         */
        VCodeDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.destroy();
        };
        VCodeDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-vcode]',
                        exportAs: 'weuiVcode',
                        host: {
                            '(click)': '_onClick()',
                            '[disabled]': '_disabled',
                        },
                    },] }
        ];
        /** @nocollapse */
        VCodeDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        VCodeDirective.propDecorators = {
            onSend: [{ type: core.Input, args: ['weui-vcode',] }],
            seconds: [{ type: core.Input, args: ['weui-seconds',] }],
            tpl: [{ type: core.Input, args: ['weui-tpl',] }],
            error: [{ type: core.Input, args: ['weui-error',] }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], VCodeDirective.prototype, "seconds", void 0);
        return VCodeDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文本域字数统计
     */
    var TextareaDirective = /** @class */ (function () {
        function TextareaDirective(el) {
            this.el = el;
            this.fillStr = '';
            this._cn = 1;
            /**
             * 最大长度，0表示不受限
             */
            this.maxlength = 0;
        }
        Object.defineProperty(TextareaDirective.prototype, "cn", {
            /**
             * 中文部分应该算多少个字符，使用 `/[^\x00-\xff]/g` 正则表达式统计中文部分（默认：1个字符）
             */
            set: /**
             * 中文部分应该算多少个字符，使用 `/[^\x00-\xff]/g` 正则表达式统计中文部分（默认：1个字符）
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._cn = value;
                this.fillStr = new Array(+value).fill('*').join('');
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TextareaDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.init();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        TextareaDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.maxlength) {
                this.init()._onChange(this._value);
            }
        };
        /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        TextareaDirective.prototype.init = /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () {
            /** @type {?} */
            var clsName = "weui-textarea-counter";
            /** @type {?} */
            var pel = (/** @type {?} */ (this)).el.nativeElement.parentElement;
            (/** @type {?} */ (this)).maxlength = +(/** @type {?} */ (this)).maxlength;
            if ((/** @type {?} */ (this)).maxlength <= 0) {
                core$1.remove(pel, '.' + clsName);
                (/** @type {?} */ (this))._count = null;
            }
            else {
                (/** @type {?} */ (this))._count = core$1.add(pel, '.' + clsName, 'div', clsName);
            }
            return (/** @type {?} */ (this));
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TextareaDirective.prototype._onChange = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!this._count)
                return;
            value = value || '';
            if (this._cn > 1) {
                value = value.replace(/[^\x00-\xff]/g, this.fillStr);
            }
            this._value = value;
            this._count.innerHTML = value.length + " / " + this.maxlength;
        };
        TextareaDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-textarea]',
                        exportAs: 'weuiTextarea',
                        host: {
                            '(input)': '_onChange($event.target?.value)',
                        },
                    },] }
        ];
        /** @nocollapse */
        TextareaDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        TextareaDirective.propDecorators = {
            maxlength: [{ type: core.Input }],
            cn: [{ type: core.Input, args: ['weui-cn',] }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], TextareaDirective.prototype, "maxlength", void 0);
        return TextareaDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [InputDirective, VCodeDirective, TextareaDirective, ChecklistDirective];
    var FormModule = /** @class */ (function () {
        function FormModule() {
        }
        FormModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: COMPONENTS,
                        exports: COMPONENTS,
                    },] }
        ];
        return FormModule;
    }());

    exports.ChecklistDirective = ChecklistDirective;
    exports.FormModule = FormModule;
    exports.InputDirective = InputDirective;
    exports.TextareaDirective = TextareaDirective;
    exports.VCodeDirective = VCodeDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-form.umd.js.map
