/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/gallery', ['exports', '@angular/animations', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].gallery = {}), global.ng.animations, global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, animations, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GalleryComponent = /** @class */ (function () {
        function GalleryComponent() {
            /**
             * 是否允许删除，默认：`true`
             */
            this.canDelete = true;
            /**
             * 删除回调
             */
            this.delete = new core.EventEmitter();
            /**
             * 隐藏回调
             */
            this.hide = new core.EventEmitter();
            /**
             * 标记是否显示，支持双向绑定
             */
            this.show = false;
            this.showChange = new core.EventEmitter();
            this._showd = false;
        }
        Object.defineProperty(GalleryComponent.prototype, "imgs", {
            /**
             * 图片数据
             *
             * - 虽然支持传递数组，但并不支持在打开后切换图片。
             */
            set: /**
             * 图片数据
             *
             * - 虽然支持传递数组，但并不支持在打开后切换图片。
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.parseImgs(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GalleryComponent.prototype, "_visibility", {
            get: /**
             * @return {?}
             */
            function () {
                return this.show ? 'show' : 'hide';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        GalleryComponent.prototype._antStart = /**
         * @return {?}
         */
        function () {
            if (this.show)
                this._showd = this.show;
        };
        /**
         * @return {?}
         */
        GalleryComponent.prototype._antDone = /**
         * @return {?}
         */
        function () {
            this._showd = this.show;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        GalleryComponent.prototype._onDel = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (this.canDelete) {
                this.delete.emit(item);
                this._onHide();
            }
            return false;
        };
        /**
         * @return {?}
         */
        GalleryComponent.prototype._onHide = /**
         * @return {?}
         */
        function () {
            this.show = false;
            this.showChange.emit(this.show);
            this.hide.emit();
        };
        /**
         * @private
         * @param {?} imgs
         * @return {?}
         */
        GalleryComponent.prototype.parseImgs = /**
         * @private
         * @param {?} imgs
         * @return {?}
         */
        function (imgs) {
            if (Array.isArray(imgs)) {
                if (imgs.length > 0) {
                    if (typeof imgs[0] === 'string') {
                        imgs = ((/** @type {?} */ (imgs))).map((/**
                         * @param {?} url
                         * @return {?}
                         */
                        function (url) {
                            return { url: url };
                        }));
                    }
                    else {
                        imgs = ((/** @type {?} */ (imgs))).map((/**
                         * @param {?} item
                         * @return {?}
                         */
                        function (item) {
                            if (item.file)
                                item.url = core$1.genImageUrl(item.file);
                            return item;
                        }));
                    }
                }
            }
            else {
                if (typeof imgs === 'string') {
                    imgs = [{ url: imgs }];
                }
                else {
                    /** @type {?} */
                    var imgUrl = core$1.genImageUrl(imgs);
                    if (imgUrl) {
                        imgs = [{ url: imgUrl }];
                    }
                }
            }
            // todo: 永远只返回一个
            // 针对未来可能直接上下个
            this._imgs = imgs && ((/** @type {?} */ (imgs))).length > 0 ? imgs.slice(0, 1) : [];
        };
        GalleryComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-gallery',
                        exportAs: 'weuiGallery',
                        template: "<div *ngIf=\"_imgs\" class=\"weui-galleries\">\n  <ng-template ngFor let-item [ngForOf]=\"_imgs\">\n    <div\n      class=\"weui-gallery\"\n      [ngStyle]=\"{ display: _showd ? 'block' : 'none' }\"\n      [@visibility]=\"_visibility\"\n      (@visibility.start)=\"_antStart($event)\"\n      (@visibility.done)=\"_antDone($event)\"\n      (click)=\"_onHide()\"\n    >\n      <span class=\"weui-gallery__img\" [ngStyle]=\"{ 'background-image': 'url(' + item?.url + ')' }\"></span>\n      <div class=\"weui-gallery__opr\" *ngIf=\"canDelete\">\n        <a href=\"#\" class=\"weui-gallery__del\" (click)=\"_onDel(item)\">\n          <i class=\"weui-icon-delete weui-icon_gallery-delete\"></i>\n        </a>\n      </div>\n    </div>\n  </ng-template>\n</div>\n",
                        animations: [
                            animations.trigger('visibility', [
                                animations.state('show', animations.style({ opacity: 1 })),
                                animations.state('hide', animations.style({ opacity: 0 })),
                                animations.transition('hide <=> show', [animations.animate(200)]),
                            ]),
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        GalleryComponent.propDecorators = {
            imgs: [{ type: core.Input }],
            canDelete: [{ type: core.Input }],
            delete: [{ type: core.Output }],
            hide: [{ type: core.Output }],
            show: [{ type: core.Input }],
            showChange: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], GalleryComponent.prototype, "canDelete", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], GalleryComponent.prototype, "show", void 0);
        return GalleryComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GalleryModule = /** @class */ (function () {
        function GalleryModule() {
        }
        GalleryModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [GalleryComponent],
                        exports: [GalleryComponent],
                        entryComponents: [GalleryComponent],
                    },] }
        ];
        return GalleryModule;
    }());

    exports.GalleryComponent = GalleryComponent;
    exports.GalleryModule = GalleryModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-gallery.umd.js.map
