/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/infiniteloader', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].infiniteloader = {}), global.ng.core, global.rxjs, global.ng.common));
}(this, function (exports, core, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderConfig = /** @class */ (function () {
        function InfiniteLoaderConfig() {
            /**
             * 容器高度，默认：`100vh`
             */
            this.height = '100vh';
            /**
             * 滚动至x%时触发加载，默认：75%
             */
            this.percent = 75;
            /**
             * 加载中文本（支持HTML），默认：weui-loadmore 组件
             */
            this.loading = '<div class="weui-loadmore"><i class="weui-loading"></i><span class="weui-loadmore__tips">加载中…</span></div>';
            /**
             * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
             */
            this.finished = '<div class="weui-loadmore weui-loadmore_line"><span class="weui-loadmore__tips">已加载完毕</span></div>';
            /**
             * 滚动节流时长（单位：ms），默认：`100`
             */
            this.throttle = 100;
        }
        InfiniteLoaderConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ InfiniteLoaderConfig.ngInjectableDef = core.defineInjectable({ factory: function InfiniteLoaderConfig_Factory() { return new InfiniteLoaderConfig(); }, token: InfiniteLoaderConfig, providedIn: "root" });
        return InfiniteLoaderConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderComponent = /** @class */ (function () {
        function InfiniteLoaderComponent(el, DEF) {
            this.el = el;
            this.DEF = DEF;
            this.didScroll = false;
            this.scrollEvent = null;
            this.scrollTime = null;
            this._loading = false;
            this._finished = false;
            this.loadmore = new core.EventEmitter();
            this.config = __assign({}, DEF);
        }
        Object.defineProperty(InfiniteLoaderComponent.prototype, "config", {
            get: /**
             * @return {?}
             */
            function () {
                return this._config;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._config = __assign({}, this.DEF, val);
            },
            enumerable: true,
            configurable: true
        });
        /** 设置本次加载完成 */
        /**
         * 设置本次加载完成
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.resolveLoading = /**
         * 设置本次加载完成
         * @return {?}
         */
        function () {
            this._loading = false;
            this._finished = false;
        };
        /** 设置结束 */
        /**
         * 设置结束
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.setFinished = /**
         * 设置结束
         * @return {?}
         */
        function () {
            this._loading = false;
            this._finished = true;
        };
        /** 设置重新开始 */
        /**
         * 设置重新开始
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.restart = /**
         * 设置重新开始
         * @return {?}
         */
        function () {
            this._finished = false;
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype._onScroll = /**
         * @return {?}
         */
        function () {
            if (this._loading || this._finished)
                return;
            /** @type {?} */
            var target = this.scrollEvent.target;
            /** @type {?} */
            var scrollPercent = Math.floor(((target.scrollTop + target.clientHeight) / target.scrollHeight) * 100);
            if (scrollPercent > (/** @type {?} */ (this.config.percent))) {
                this._loading = true;
                this.loadmore.emit(this);
            }
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.scrollTime = setInterval((/**
             * @return {?}
             */
            function () {
                if (_this.didScroll) {
                    _this.didScroll = false;
                    _this._onScroll();
                }
            }), this.config.throttle);
            this.disposeScroller = rxjs.fromEvent((/** @type {?} */ (this.el.nativeElement.querySelector('.weui-infiniteloader__content'))), 'scroll').subscribe((/**
             * @param {?} $event
             * @return {?}
             */
            function ($event) {
                _this.scrollEvent = $event;
                _this.didScroll = true;
            }));
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.scrollTime)
                clearTimeout(this.scrollTime);
            if (this.disposeScroller)
                this.disposeScroller.unsubscribe();
        };
        InfiniteLoaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-infiniteloader',
                        exportAs: 'weuiInfiniteloader',
                        template: "<div class=\"weui-infiniteloader__content\">\n  <ng-content></ng-content>\n  <div *ngIf=\"_loading || _finished\">\n    <div *ngIf=\"_loading\" [innerHTML]=\"config.loading\"></div>\n    <div *ngIf=\"_finished\" [innerHTML]=\"config.finished\"></div>\n  </div>\n</div>\n",
                        host: {
                            '[class.weui-infiniteloader]': 'true',
                            '[style.height]': 'config.height',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        InfiniteLoaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: InfiniteLoaderConfig }
        ]; };
        InfiniteLoaderComponent.propDecorators = {
            config: [{ type: core.Input }],
            loadmore: [{ type: core.Output }]
        };
        return InfiniteLoaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderModule = /** @class */ (function () {
        function InfiniteLoaderModule() {
        }
        InfiniteLoaderModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [InfiniteLoaderComponent],
                        exports: [InfiniteLoaderComponent],
                    },] }
        ];
        return InfiniteLoaderModule;
    }());

    exports.InfiniteLoaderComponent = InfiniteLoaderComponent;
    exports.InfiniteLoaderConfig = InfiniteLoaderConfig;
    exports.InfiniteLoaderModule = InfiniteLoaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-infiniteloader.umd.js.map
