/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/mask', ['exports', '@angular/core', 'ngx-weui/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].mask = {}), global.ng.core, global['ngx-weui'].core, global.rxjs, global.ng.common));
}(this, function (exports, core, core$1, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaskComponent = /** @class */ (function () {
        function MaskComponent(cdr) {
            this.cdr = cdr;
            this._shown = false;
            /**
             * 点击是否允许关闭（默认：`false`）
             */
            this.backdrop = false;
            /**
             * 内容方向（默认：`vertical`）
             * + `top`: 顶部居中
             * + `bottom`: 底部居中
             * + `vertical-left`: 垂直居左
             * + `vertical`: 垂直居中
             * + `vertical-right`: 垂直居右
             * + `none`: 无
             */
            this.placement = 'vertical';
            /**
             * 内容背景色
             */
            this.bg = '';
            /**
             * 内容为Loading效果（默认：`false`）
             */
            this.loading = false;
            /**
             * 关闭回调
             */
            this.close = new core.EventEmitter();
        }
        /**
         * 显示，并返回一个Observable
         */
        /**
         * 显示，并返回一个Observable
         * @return {?}
         */
        MaskComponent.prototype.show = /**
         * 显示，并返回一个Observable
         * @return {?}
         */
        function () {
            var _this = this;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._shown = true;
                _this.cdr.detectChanges();
            }));
            return rxjs.Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param is_backdrop 是否手动点击关闭（默认：false）
         */
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否手动点击关闭（默认：false）
         * @return {?}
         */
        MaskComponent.prototype.hide = /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否手动点击关闭（默认：false）
         * @return {?}
         */
        function (is_backdrop) {
            if (is_backdrop === void 0) { is_backdrop = false; }
            if (is_backdrop === true && this.backdrop === false)
                return false;
            this._shown = false;
            this.cdr.detectChanges();
            this.close.emit();
        };
        /**
         * @return {?}
         */
        MaskComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                ((/** @type {?} */ (this.observer))).unsubscribe();
            }
        };
        MaskComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-mask',
                        exportAs: 'weuiMask',
                        template: "<div class=\"weui-mask\" [ngClass]=\"{ 'weui-mask__visible': _shown }\" (click)=\"hide(true)\">\n  <div class=\"weui-mask__content\" [ngClass]=\"placement !== 'none' ? 'weui-mask__' + placement : ''\">\n    <div [ngStyle]=\"{ 'background-color': bg }\">\n      <div *ngIf=\"loading\"><i class=\"weui-loading weui-icon_toast\"></i></div>\n      <ng-content></ng-content>\n    </div>\n  </div>\n</div>\n",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        MaskComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        MaskComponent.propDecorators = {
            backdrop: [{ type: core.Input }],
            placement: [{ type: core.Input }],
            bg: [{ type: core.Input }],
            loading: [{ type: core.Input }],
            close: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], MaskComponent.prototype, "backdrop", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Object)
        ], MaskComponent.prototype, "loading", void 0);
        return MaskComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaskModule = /** @class */ (function () {
        function MaskModule() {
        }
        MaskModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [MaskComponent],
                        exports: [MaskComponent],
                        entryComponents: [MaskComponent],
                    },] }
        ];
        return MaskModule;
    }());

    exports.MaskComponent = MaskComponent;
    exports.MaskModule = MaskModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-mask.umd.js.map
