/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common'), require('ngx-weui/button')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/pagination', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common', 'ngx-weui/button'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].pagination = {}), global.ng.core, global['ngx-weui'].core, global.ng.common, global['ngx-weui'].button));
}(this, function (exports, core, core$1, common, button) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PaginationConfig = /** @class */ (function () {
        function PaginationConfig() {
            /**
             * 形态，可选 `button`,`pointer`，默认：`button`
             */
            this.mode = 'button';
            /**
             * 是否隐藏数值，默认：`false`
             */
            this.simple = false;
            /**
             * 小号按钮，默认：`true`
             */
            this.mini = true;
            /**
             * 上一页文本（支持HTML），默认：`上一页`
             */
            this.prevText = '上一页';
            /**
             * 下一页文本（支持HTML），默认：`下一步`
             */
            this.nextText = '下一步';
        }
        PaginationConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ PaginationConfig.ngInjectableDef = core.defineInjectable({ factory: function PaginationConfig_Factory() { return new PaginationConfig(); }, token: PaginationConfig, providedIn: "root" });
        return PaginationConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PaginationComponent = /** @class */ (function () {
        function PaginationComponent(cog) {
            this._ptArr = [];
            this._prevDisabled = false;
            this._nextDisabled = false;
            /**
             * 当前索引
             */
            this.current = 0;
            /**
             * 数据总数
             */
            this.total = 0;
            /**
             * 小号按钮，默认：`true`
             */
            this.mini = true;
            /**
             * 分页触发的回调函数
             */
            this.change = new core.EventEmitter();
            Object.assign(this, cog);
        }
        /**
         * @return {?}
         */
        PaginationComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (this.mode === 'pointer')
                this._ptArr = Array(this.total)
                    .fill(1)
                    .map((/**
                 * @param {?} v
                 * @param {?} i
                 * @return {?}
                 */
                function (v, i) { return v + i; }));
            this._checkDisabled();
        };
        /**
         * @return {?}
         */
        PaginationComponent.prototype._checkDisabled = /**
         * @return {?}
         */
        function () {
            if (this.mode === 'pointer')
                return;
            this._prevDisabled = this.current <= 1;
            this._nextDisabled = this.current >= this.total;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        PaginationComponent.prototype._goto = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value === -1 && this._prevDisabled)
                return false;
            if (value === 1 && this._nextDisabled)
                return false;
            this.current += value;
            this._checkDisabled();
            this.change.emit(this.current);
        };
        PaginationComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-pagination',
                        exportAs: 'weuiPagination',
                        template: "<ng-template [ngIf]=\"mode === 'button'\">\n  <div class=\"weui-pagination__item weui-pagination__prev\">\n    <a\n      weui-button\n      (click)=\"_goto(-1)\"\n      weui-plain\n      [weui-mini]=\"mini\"\n      weui-type=\"default\"\n      [disabled]=\"_prevDisabled\"\n      [innerHTML]=\"prevText\"\n    ></a>\n  </div>\n  <div class=\"weui-pagination__item weui-pagination__num\" *ngIf=\"!simple\">{{ current }}/{{ total }}</div>\n  <div class=\"weui-pagination__item weui-pagination__next\">\n    <a\n      weui-button\n      (click)=\"_goto(1)\"\n      weui-plain\n      [weui-mini]=\"mini\"\n      weui-type=\"default\"\n      [disabled]=\"_nextDisabled\"\n      [innerHTML]=\"nextText\"\n    ></a>\n  </div>\n</ng-template>\n<div class=\"weui-pagination__item weui-pagination__num\" *ngIf=\"mode === 'pointer'\">\n  <div *ngFor=\"let i of _ptArr\" class=\"weui-pagination__dot\" [class.weui-pagination__dot-active]=\"current === i\">\n    <span></span>\n  </div>\n</div>\n",
                        host: {
                            class: 'weui-pagination',
                            '[class.weui-pagination__non-mini]': '!mini',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        PaginationComponent.ctorParameters = function () { return [
            { type: PaginationConfig }
        ]; };
        PaginationComponent.propDecorators = {
            mode: [{ type: core.Input }],
            current: [{ type: core.Input }],
            total: [{ type: core.Input }],
            simple: [{ type: core.Input }],
            mini: [{ type: core.Input }],
            prevText: [{ type: core.Input }],
            nextText: [{ type: core.Input }],
            change: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], PaginationComponent.prototype, "current", void 0);
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], PaginationComponent.prototype, "total", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], PaginationComponent.prototype, "simple", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], PaginationComponent.prototype, "mini", void 0);
        return PaginationComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PaginationModule = /** @class */ (function () {
        function PaginationModule() {
        }
        PaginationModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, button.ButtonModule],
                        declarations: [PaginationComponent],
                        exports: [PaginationComponent],
                    },] }
        ];
        return PaginationModule;
    }());

    exports.PaginationComponent = PaginationComponent;
    exports.PaginationConfig = PaginationConfig;
    exports.PaginationModule = PaginationModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-pagination.umd.js.map
