/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/popup', ['exports', '@angular/animations', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].popup = {}), global.ng.animations, global.ng.core, global.rxjs, global.ng.common));
}(this, function (exports, animations, core, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupConfig = /** @class */ (function () {
        function PopupConfig() {
            /**
             * 是否全屏，默认：`false`
             */
            this.is_full = false;
            /**
             * 取消按钮文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 确定按钮文本，默认：`确定`
             */
            this.confirm = '确定';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        PopupConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ PopupConfig.ngInjectableDef = core.defineInjectable({ factory: function PopupConfig_Factory() { return new PopupConfig(); }, token: PopupConfig, providedIn: "root" });
        return PopupConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupComponent = /** @class */ (function () {
        function PopupComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            this.shown = false;
            this._shownAnt = false;
            this.cancel = new core.EventEmitter();
            this.confirm = new core.EventEmitter();
            this.config = __assign({}, DEF);
        }
        Object.defineProperty(PopupComponent.prototype, "config", {
            get: /**
             * @return {?}
             */
            function () {
                return this._config;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._config = __assign({}, this.DEF, val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PopupComponent.prototype, "_visibility", {
            get: /**
             * @return {?}
             */
            function () {
                return this._shownAnt ? 'show' : 'hide';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * 显示，并支持订阅结果，如果点击取消值为false，反之 true
         */
        /**
         * 显示，并支持订阅结果，如果点击取消值为false，反之 true
         * @return {?}
         */
        PopupComponent.prototype.show = /**
         * 显示，并支持订阅结果，如果点击取消值为false，反之 true
         * @return {?}
         */
        function () {
            var _this = this;
            this.shown = true;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._shownAnt = true;
                _this.cdr.detectChanges();
            }), 10);
            return rxjs.Observable.create((/**
             * @param {?} observer
             * @return {?}
             */
            function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param [is_backdrop] 是否从背景上点击(可选)
         */
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop
         * @return {?}
         */
        PopupComponent.prototype.hide = /**
         * 隐藏
         *
         * @param {?=} is_backdrop
         * @return {?}
         */
        function (is_backdrop) {
            var _this = this;
            if (is_backdrop === true && this.config.backdrop === false)
                return false;
            this._shownAnt = false;
            this.cdr.detectChanges();
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.shown = false;
            }), 300);
        };
        /** 关闭，等同 `hide()` 效果 */
        /**
         * 关闭，等同 `hide()` 效果
         * @return {?}
         */
        PopupComponent.prototype.close = /**
         * 关闭，等同 `hide()` 效果
         * @return {?}
         */
        function () {
            this.hide(false);
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            this.cancel.emit();
            this.hide(false);
            if (this.observer) {
                this.observer.next(false);
                this.observer.complete();
            }
            return false;
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype._onConfirm = /**
         * @return {?}
         */
        function () {
            this.confirm.emit();
            this.hide(false);
            if (this.observer) {
                this.observer.next(true);
                this.observer.complete();
            }
            return false;
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                this.observer.unsubscribe();
            }
        };
        PopupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-popup',
                        exportAs: 'weuiPopup',
                        template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-popup\" [ngClass]=\"{ 'weui-popup_toggle': _shownAnt }\">\n  <div class=\"weui-popup__hd\" *ngIf=\"!config.is_full\">\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onCancel()\">{{ config.cancel }}</a>\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onConfirm()\">{{ config.confirm }}</a>\n  </div>\n  <div [ngClass]=\"{ 'weui-popup_full': config.is_full }\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                        animations: [
                            animations.trigger('visibility', [
                                animations.state('show', animations.style({ opacity: 1 })),
                                animations.state('hide', animations.style({ opacity: 0 })),
                                animations.transition('hide <=> show', [animations.animate(200)]),
                            ]),
                        ],
                        host: {
                            '[hidden]': '!shown',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        PopupComponent.ctorParameters = function () { return [
            { type: PopupConfig },
            { type: core.ChangeDetectorRef }
        ]; };
        PopupComponent.propDecorators = {
            config: [{ type: core.Input }],
            cancel: [{ type: core.Output }],
            confirm: [{ type: core.Output }]
        };
        return PopupComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupModule = /** @class */ (function () {
        function PopupModule() {
        }
        PopupModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [PopupComponent],
                        exports: [PopupComponent],
                        entryComponents: [PopupComponent],
                    },] }
        ];
        return PopupModule;
    }());

    exports.PopupComponent = PopupComponent;
    exports.PopupConfig = PopupConfig;
    exports.PopupModule = PopupModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-popup.umd.js.map
