/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/progress', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].progress = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ProgressComponent = /** @class */ (function () {
        function ProgressComponent(cdr) {
            this.cdr = cdr;
            this._value = 0;
            /**
             * 是否允许取消，默认：`true`
             */
            this.canCancel = true;
            /**
             * 取消回调
             */
            this.cancel = new core.EventEmitter();
        }
        Object.defineProperty(ProgressComponent.prototype, "value", {
            /**
             * 默认进度值，取值范围：0-100（单位：%）
             */
            set: /**
             * 默认进度值，取值范围：0-100（单位：%）
             * @param {?} d
             * @return {?}
             */
            function (d) {
                this._value = Math.max(0, Math.min(100, d));
                this.cdr.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ProgressComponent.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            if (this.canCancel)
                this.cancel.emit();
            return false;
        };
        ProgressComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-progress',
                        exportAs: 'weuiProgress',
                        template: "<div class=\"weui-progress\">\n  <div class=\"weui-progress__bar\">\n    <div class=\"weui-progress__inner-bar\" [style.width]=\"_value + '%'\"></div>\n  </div>\n  <a href=\"#\" class=\"weui-progress__opr\" *ngIf=\"canCancel\" (click)=\"_onCancel()\">\n    <i class=\"weui-icon-cancel\"></i>\n  </a>\n</div>\n",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ProgressComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        ProgressComponent.propDecorators = {
            value: [{ type: core.Input }],
            canCancel: [{ type: core.Input }],
            cancel: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number),
            __metadata("design:paramtypes", [Number])
        ], ProgressComponent.prototype, "value", null);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], ProgressComponent.prototype, "canCancel", void 0);
        return ProgressComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ProgressModule = /** @class */ (function () {
        function ProgressModule() {
        }
        ProgressModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ProgressComponent],
                        exports: [ProgressComponent],
                        entryComponents: [ProgressComponent],
                    },] }
        ];
        return ProgressModule;
    }());

    exports.ProgressComponent = ProgressComponent;
    exports.ProgressModule = ProgressModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-progress.umd.js.map
