/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/ptr', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].ptr = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRConfig = /** @class */ (function () {
        function PTRConfig() {
            /**
             * 是否使用默认icon样式，默认：`false`
             */
            this.customIcon = false;
            /**
             * 下拉icon，支持HTML
             */
            this.pullIcon = '<i class="weui-icon-download"></i>';
            /**
             * 加载中icon，支持HTML
             */
            this.loadingIcon = '<i class="weui-loading"></i>';
            /**
             * 加载成功icon，支持HTML
             */
            this.successIcon = '<i class="weui-icon-success"></i>';
            /**
             * 下拉刷新容器高度（单位：px），默认：`100`
             */
            this.height = 100;
            /**
             * 下拉范围有效（单位：%），默认：`80`
             */
            this.treshold = 80;
        }
        PTRConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ PTRConfig.ngInjectableDef = core.defineInjectable({ factory: function PTRConfig_Factory() { return new PTRConfig(); }, token: PTRConfig, providedIn: "root" });
        return PTRConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRComponent = /** @class */ (function () {
        function PTRComponent(el, DEF, cdr) {
            this.el = el;
            this.DEF = DEF;
            this.cdr = cdr;
            this.ogY = 0;
            this.loading = false;
            this.touching = false;
            this.initScrollTop = 0;
            this._animating = false;
            this._pullPercent = 0;
            /**
             * 是否禁止
             */
            this.disabled = false;
            /**
             * 下拉滚动时回调，返回一个0-100%的参数
             */
            this.scroll = new core.EventEmitter();
            /**
             * 刷新回调
             */
            this.refresh = new core.EventEmitter();
            this.config = __assign({}, DEF);
        }
        Object.defineProperty(PTRComponent.prototype, "config", {
            get: /**
             * @return {?}
             */
            function () {
                return this._config;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._config = __assign({}, this.DEF, val);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * 设置最后更新标签
         *
         * @param label 标签内容（支持HTML）
         */
        /**
         * 设置最后更新标签
         *
         * @param {?} label 标签内容（支持HTML）
         * @return {?}
         */
        PTRComponent.prototype.setLastUpdatedLabel = /**
         * 设置最后更新标签
         *
         * @param {?} label 标签内容（支持HTML）
         * @return {?}
         */
        function (label) {
            this._lastLabel = label;
            this.cdr.detectChanges();
        };
        /**
         * 设置刷新成功
         *
         * @param [lastUpdatedLabel] label 标签内容（支持HTML）
         */
        /**
         * 设置刷新成功
         *
         * @param {?=} lastUpdatedLabel
         * @return {?}
         */
        PTRComponent.prototype.setFinished = /**
         * 设置刷新成功
         *
         * @param {?=} lastUpdatedLabel
         * @return {?}
         */
        function (lastUpdatedLabel) {
            var _this = this;
            this._pullPercent = 0;
            this.loading = false;
            this._animating = true;
            this.cdr.detectChanges();
            if (!this.touching) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this._animating = false;
                    if (lastUpdatedLabel)
                        _this.setLastUpdatedLabel(lastUpdatedLabel);
                    _this.cdr.detectChanges();
                }), 350);
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        PTRComponent.prototype.onTouchStart = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (this.disabled || this.touching || this.loading)
                return;
            this.touching = true;
            this.touchId = $event.targetTouches[0].identifier;
            this.ogY =
                this._pullPercent === 0 ? $event.targetTouches[0].pageY : $event.targetTouches[0].pageY - this._pullPercent;
            this.initScrollTop = this.contentEl.scrollTop;
            this._animating = false;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        PTRComponent.prototype.onTouchMove = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (this.disabled || !this.touching || this.loading)
                return;
            if ($event.targetTouches[0].identifier !== this.touchId)
                return;
            /** @type {?} */
            var pageY = $event.targetTouches[0].pageY;
            /** @type {?} */
            var diffY = pageY - this.ogY;
            // if it's scroll
            if (diffY < 0)
                return;
            // if it's not at top
            if (this.contentEl.scrollTop > 0)
                return;
            $event.preventDefault();
            // let diffY = Math.abs(this.ogY - pageY);
            this._pullPercent = diffY - this.initScrollTop > 100 ? 100 : diffY - this.initScrollTop;
            this.scroll.emit(this._pullPercent);
        };
        /**
         * @return {?}
         */
        PTRComponent.prototype.onTouchEnd = /**
         * @return {?}
         */
        function () {
            if (this.disabled || !this.touching || this.loading)
                return;
            /** @type {?} */
            var _pullPercent = this._pullPercent;
            /** @type {?} */
            var loading = false;
            if (_pullPercent >= (/** @type {?} */ (this.config.treshold))) {
                loading = true;
            }
            else {
                _pullPercent = 0;
            }
            this.touching = false;
            this.ogY = 0;
            this.touchId = undefined;
            this.initScrollTop = 0;
            this._animating = loading;
            this._pullPercent = _pullPercent;
            this.loading = loading;
            if (loading)
                this.refresh.emit(this);
            this.cdr.detectChanges();
        };
        /**
         * @return {?}
         */
        PTRComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.contentEl = (/** @type {?} */ ((/** @type {?} */ (this.el.nativeElement.querySelector('.weui-ptr__content')))));
        };
        PTRComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-ptr',
                        exportAs: 'weuiPtr',
                        template: "<div\n  class=\"weui-ptr__loader\"\n  [ngStyle]=\"{\n    'height.px': config.height,\n    'margin-top.px': -config.height! + _pullPercent / (100 / config.height!),\n    transition: _animating ? 'all .5s' : 'none'\n  }\"\n>\n  <div style=\"flex: 1 1 0%; padding: 5px;\" *ngIf=\"!config.customIcon\">\n    <span\n      [innerHTML]=\"_pullPercent !== 100 ? config.pullIcon : loading ? config.loadingIcon : config.successIcon\"\n      class=\"weui-ptr__icon\"\n      style=\"display:inline-block\"\n      [ngStyle]=\"{\n        transform: 'rotate(' + -(_pullPercent !== 100 ? _pullPercent * 1.8 : 0) + 'deg)',\n        color: _pullPercent !== 100 ? '#5f5f5f' : '#1AAD19'\n      }\"\n    ></span>\n    <p *ngIf=\"_lastLabel\" class=\"weui-ptr__label\">{{ _lastLabel }}</p>\n  </div>\n  <ng-content select=\"[loader]\"></ng-content>\n</div>\n<div class=\"weui-ptr__content\"><ng-content></ng-content></div>\n",
                        host: {
                            '[class.weui-ptr]': 'true',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        PTRComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: PTRConfig },
            { type: core.ChangeDetectorRef }
        ]; };
        PTRComponent.propDecorators = {
            config: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            scroll: [{ type: core.Output }],
            refresh: [{ type: core.Output }],
            onTouchStart: [{ type: core.HostListener, args: ['touchstart', ['$event'],] }],
            onTouchMove: [{ type: core.HostListener, args: ['touchmove', ['$event'],] }],
            onTouchEnd: [{ type: core.HostListener, args: ['touchend',] }, { type: core.HostListener, args: ['touchcancel',] }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], PTRComponent.prototype, "disabled", void 0);
        return PTRComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRModule = /** @class */ (function () {
        function PTRModule() {
        }
        PTRModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [PTRComponent],
                        exports: [PTRComponent],
                        entryComponents: [PTRComponent],
                    },] }
        ];
        return PTRModule;
    }());

    exports.PTRComponent = PTRComponent;
    exports.PTRConfig = PTRConfig;
    exports.PTRModule = PTRModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-ptr.umd.js.map
