/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/rating', ['exports', '@angular/core', '@angular/forms', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].rating = {}), global.ng.core, global.ng.forms, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, forms, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RatingConfig = /** @class */ (function () {
        function RatingConfig() {
            /**
             * 图标数量（默认：5个）
             */
            this.max = 5;
            /**
             * 样式名
             */
            this.cls = '';
            /**
             * 未选中图标，默认：`weui-icon-circle`
             */
            this.stateOff = 'weui-icon-circle';
            /**
             * 选中图标，默认：`weui-icon-success`
             */
            this.stateOn = 'weui-icon-success';
            /**
             * 自定义图标，当存在时 `max`、`stateOff`、`stateOn` 失效
             */
            this.states = [];
            /**
             * 图标 `title` 属性值，默认以 `1` 开始的索引值
             */
            this.titles = [];
        }
        RatingConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ RatingConfig.ngInjectableDef = core.defineInjectable({ factory: function RatingConfig_Factory() { return new RatingConfig(); }, token: RatingConfig, providedIn: "root" });
        return RatingConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RatingComponent = /** @class */ (function () {
        function RatingComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            /**
             * 是否只读模式，默认：`false`
             */
            this.readonly = false;
            /**
             * 选中后回调，参数：选中值
             */
            this.selected = new core.EventEmitter();
            this._class = '';
            this.onChange = Function.prototype;
        }
        /**
         * @private
         * @param {?} cog
         * @return {?}
         */
        RatingComponent.prototype.setConfig = /**
         * @private
         * @param {?} cog
         * @return {?}
         */
        function (cog) {
            /** @type {?} */
            var _c = __assign({ states: [] }, this.DEF, cog);
            this._class = _c.cls || '';
            /** @type {?} */
            var count = _c.states.length || _c.max;
            this._range = Array(count)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} i
             * @return {?}
             */
            function (_v, i) {
                return __assign({ index: i, on: _c.stateOn, off: _c.stateOff, title: (/** @type {?} */ (_c.titles))[i] || i + 1 }, (_c.states[i] || {}));
            }));
            this.cdr.detectChanges();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        RatingComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.config) {
                this.setConfig(changes.config.currentValue);
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        RatingComponent.prototype._rate = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!this.readonly && value >= 0 && value <= this._range.length) {
                this.writeValue(value);
                this.onChange(value);
            }
            this.cdr.detectChanges();
        };
        /**
         * @param {?} _value
         * @return {?}
         */
        RatingComponent.prototype.writeValue = /**
         * @param {?} _value
         * @return {?}
         */
        function (_value) {
            if (_value % 1 !== _value) {
                this._value = Math.round(_value);
                this._preValue = _value;
                this.cdr.detectChanges();
                return;
            }
            this._preValue = _value;
            this._value = _value;
            this.cdr.detectChanges();
        };
        // private onTouched: any = Function.prototype;
        // private onTouched: any = Function.prototype;
        /**
         * @param {?} fn
         * @return {?}
         */
        RatingComponent.prototype.registerOnChange = 
        // private onTouched: any = Function.prototype;
        /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} _fn
         * @return {?}
         */
        RatingComponent.prototype.registerOnTouched = /**
         * @param {?} _fn
         * @return {?}
         */
        function (_fn) {
            // this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        RatingComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.readonly = isDisabled;
        };
        RatingComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-rating',
                        exportAs: 'weuiRating',
                        template: "<span\n  class=\"weui-rating__container{{ _class ? ' ' + _class : '' }}\"\n  tabindex=\"0\"\n  role=\"slider\"\n  aria-valuemin=\"0\"\n  [attr.aria-valuemax]=\"_range.length\"\n  [attr.aria-valuenow]=\"_value\"\n>\n  <ng-template ngFor let-r [ngForOf]=\"_range\" let-index=\"index\">\n    <span class=\"weui-rating__sr-only\">({{ index < _value ? '*' : ' ' }})</span>\n    <i (click)=\"_rate(index + 1)\" [ngClass]=\"index < _value ? r.on : r.off\" [title]=\"r.title\"></i>\n  </ng-template>\n</span>\n",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return RatingComponent; })),
                                multi: true,
                            },
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        RatingComponent.ctorParameters = function () { return [
            { type: RatingConfig },
            { type: core.ChangeDetectorRef }
        ]; };
        RatingComponent.propDecorators = {
            config: [{ type: core.Input }],
            readonly: [{ type: core.Input }],
            selected: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], RatingComponent.prototype, "readonly", void 0);
        return RatingComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RatingModule = /** @class */ (function () {
        function RatingModule() {
        }
        RatingModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [RatingComponent],
                        exports: [RatingComponent],
                    },] }
        ];
        return RatingModule;
    }());

    exports.RatingComponent = RatingComponent;
    exports.RatingConfig = RatingConfig;
    exports.RatingModule = RatingModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-rating.umd.js.map
