/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/searchbar', ['exports', '@angular/core', 'ngx-weui/core', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].searchbar = {}), global.ng.core, global['ngx-weui'].core, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.forms));
}(this, function (exports, core, core$1, rxjs, operators, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarConfig = /** @class */ (function () {
        function SearchBarConfig() {
            /**
             * 占位符，默认：`搜索`
             */
            this.placeholder = '搜索';
            /**
             * 取消按键文字，默认：`取消`
             */
            this.cancelText = '取消';
            /**
             * 去抖时长（单位：ms），默认：`300`
             */
            this.debounceTime = 300;
        }
        SearchBarConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SearchBarConfig.ngInjectableDef = core.defineInjectable({ factory: function SearchBarConfig_Factory() { return new SearchBarConfig(); }, token: SearchBarConfig, providedIn: "root" });
        return SearchBarConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarComponent = /** @class */ (function () {
        function SearchBarComponent(DEF) {
            this._q = '';
            /**
             * 搜索回调
             */
            this.search = new core.EventEmitter();
            /**
             * 取消回调
             */
            this.cancel = new core.EventEmitter();
            /**
             * 清空回调
             */
            this.clear = new core.EventEmitter();
            /**
             * 提交回调（指的是键盘回车后）
             */
            this.submit = new core.EventEmitter();
            this._focus = false;
            this._subject = new rxjs.Subject();
            Object.assign(this, DEF);
        }
        Object.defineProperty(SearchBarComponent.prototype, "value", {
            set: /**
             * @param {?} _value
             * @return {?}
             */
            function (_value) {
                this._q = _value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        SearchBarComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._sub = this._subject
                .pipe(operators.debounceTime(this.debounceTime), operators.distinctUntilChanged())
                .subscribe((/**
             * @param {?} q
             * @return {?}
             */
            function (q) {
                _this.search.emit(q);
            }));
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._doFocus = /**
         * @return {?}
         */
        function () {
            this._term.nativeElement.focus();
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onBlur = /**
         * @return {?}
         */
        function () {
            if (this._q === '')
                this._focus = false;
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onSearch = /**
         * @return {?}
         */
        function () {
            this._subject.next(this._q);
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            this._q = '';
            this._onBlur();
            this._subject.next('');
            this.cancel.emit();
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onClear = /**
         * @return {?}
         */
        function () {
            this._q = '';
            this._doFocus();
            this._subject.next('');
            this.clear.emit();
        };
        /**
         * @param {?} e
         * @return {?}
         */
        SearchBarComponent.prototype._onSubmit = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            e.preventDefault();
            e.stopPropagation();
            this._subject.next(this._q);
            this.submit.emit(this._q);
            return false;
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this._sub)
                this._sub.unsubscribe();
        };
        SearchBarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-searchbar',
                        exportAs: 'weuiSearchbar',
                        template: "<div class=\"weui-search-bar\" [ngClass]=\"{ 'weui-search-bar_focusing': _focus }\">\n  <form class=\"weui-search-bar__form\" (ngSubmit)=\"_onSubmit($event)\">\n    <div class=\"weui-search-bar__box\">\n      <i class=\"weui-icon-search\"></i>\n      <input\n        #term\n        type=\"search\"\n        autocomplete=\"off\"\n        name=\"q\"\n        class=\"weui-search-bar__input\"\n        [placeholder]=\"placeholder\"\n        [(ngModel)]=\"_q\"\n        (ngModelChange)=\"_onSearch()\"\n        (focus)=\"_focus = true\"\n        (blur)=\"_onBlur()\"\n      />\n      <a href=\"javascript:\" class=\"weui-icon-clear\" (click)=\"_onClear()\"></a>\n    </div>\n    <label class=\"weui-search-bar__label\" (click)=\"_doFocus()\">\n      <i class=\"weui-icon-search\"></i>\n      <span>{{ placeholder }}</span>\n    </label>\n  </form>\n  <a href=\"javascript:\" class=\"weui-search-bar__cancel-btn\" (click)=\"_onCancel()\">{{ cancelText }}</a>\n</div>\n",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        SearchBarComponent.ctorParameters = function () { return [
            { type: SearchBarConfig }
        ]; };
        SearchBarComponent.propDecorators = {
            value: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            cancelText: [{ type: core.Input }],
            debounceTime: [{ type: core.Input }],
            search: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            clear: [{ type: core.Output }],
            submit: [{ type: core.Output }],
            _term: [{ type: core.ViewChild, args: ['term',] }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], SearchBarComponent.prototype, "debounceTime", void 0);
        return SearchBarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarModule = /** @class */ (function () {
        function SearchBarModule() {
        }
        SearchBarModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [SearchBarComponent],
                        exports: [SearchBarComponent],
                    },] }
        ];
        return SearchBarModule;
    }());

    exports.SearchBarComponent = SearchBarComponent;
    exports.SearchBarConfig = SearchBarConfig;
    exports.SearchBarModule = SearchBarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-searchbar.umd.js.map
