/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/sidebar', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common', 'rxjs'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].sidebar = {}), global.ng.core, global['ngx-weui'].core, global.ng.common, global.rxjs));
}(this, function (exports, core, core$1, common, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SidebarConfig = /** @class */ (function () {
        function SidebarConfig() {
            /**
             * 位置方向，默认：`left`
             */
            this.position = 'left';
            /**
             * 类型，默认：`slide`
             * - over: 不覆盖
             * - slide：侧边移动
             */
            this.mode = 'slide';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        SidebarConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SidebarConfig.ngInjectableDef = core.defineInjectable({ factory: function SidebarConfig_Factory() { return new SidebarConfig(); }, token: SidebarConfig, providedIn: "root" });
        return SidebarConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SidebarService = /** @class */ (function () {
        function SidebarService() {
            this._openObserver = new rxjs.Subject();
            this._closeObserver = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        SidebarService.prototype.open = /**
         * @return {?}
         */
        function () {
            this._openObserver.next();
        };
        /**
         * @return {?}
         */
        SidebarService.prototype.close = /**
         * @return {?}
         */
        function () {
            this._closeObserver.next();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SidebarService.prototype.onOpen = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            return this._openObserver.subscribe(fn);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SidebarService.prototype.onClose = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            return this._closeObserver.subscribe(fn);
        };
        SidebarService.decorators = [
            { type: core.Injectable }
        ];
        return SidebarService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 侧边栏
     */
    var SidebarComponent = /** @class */ (function () {
        function SidebarComponent(_sidebarService, config, doc) {
            this._sidebarService = _sidebarService;
            this.doc = doc;
            /**
             * 状态，true表示打开，false表示关闭
             */
            this.status = false;
            this.statusChange = new core.EventEmitter();
            /**
             * 位置方向，默认：`left`
             */
            this.position = 'left';
            /**
             * 类型，默认：`slide`
             * - over: 不覆盖
             * - slide：侧边移动
             */
            this.mode = 'slide';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
            /**
             * 打开前回调
             */
            this.openStart = new core.EventEmitter();
            /**
             * 打开后回调
             */
            this.opened = new core.EventEmitter();
            /**
             * 关闭前回调
             */
            this.closeStart = new core.EventEmitter();
            /**
             * 关闭后回调
             */
            this.closed = new core.EventEmitter();
            /**
             * 模式变更通知
             */
            this.modeChange = new core.EventEmitter();
            /**
             * 位置变更通知
             */
            this.positionChange = new core.EventEmitter();
            this._rerender = new core.EventEmitter();
            this._clickEvent = 'click';
            this._onClickOutsideAttached = false;
            this._anting = false;
            Object.assign(this, config);
            if (core$1.isIOS() && 'ontouchstart' in window) {
                this._clickEvent = 'touchstart';
            }
            this.open = this.open.bind(this);
            this.close = this.close.bind(this);
            this._onClickOutside = this._onClickOutside.bind(this);
            this._openSub = this._sidebarService.onOpen(this.open);
            this._closeSub = this._sidebarService.onClose(this.close);
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        SidebarComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.status && !this._anting) {
                if (changes.status.currentValue) {
                    this.open();
                }
                else {
                    this.close();
                }
                if (changes.status.firstChange)
                    this._anting = false;
            }
            if (changes.mode) {
                this.modeChange.emit(changes.mode.currentValue);
            }
            if (changes.position) {
                this.positionChange.emit(changes.position.currentValue);
            }
            if (changes.backdrop) {
                this._initCloseListeners();
            }
        };
        /**
         * @return {?}
         */
        SidebarComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroyCloseListeners();
            if (this._openSub) {
                this._openSub.unsubscribe();
            }
            if (this._closeSub) {
                this._closeSub.unsubscribe();
            }
        };
        /** 打开侧边栏 */
        /**
         * 打开侧边栏
         * @return {?}
         */
        SidebarComponent.prototype.open = /**
         * 打开侧边栏
         * @return {?}
         */
        function () {
            this._anting = true;
            this.status = true;
            this.statusChange.emit(true);
            this.openStart.emit();
            this.closeAnt();
        };
        /** 关闭侧边栏 */
        /**
         * 关闭侧边栏
         * @return {?}
         */
        SidebarComponent.prototype.close = /**
         * 关闭侧边栏
         * @return {?}
         */
        function () {
            this._anting = true;
            this.status = false;
            this.statusChange.emit(false);
            this.closeStart.emit();
            this.closeAnt();
        };
        /** 手动触发容器的重新渲染 */
        /**
         * 手动触发容器的重新渲染
         * @return {?}
         */
        SidebarComponent.prototype._triggerRerender = /**
         * 手动触发容器的重新渲染
         * @return {?}
         */
        function () {
            this._rerender.emit();
        };
        /**
         * @return {?}
         */
        SidebarComponent.prototype._getStyle = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var transformStyle = 'none';
            /** @type {?} */
            var marginStyle = {};
            /** @type {?} */
            var isSlideMode = this.mode === 'slide';
            if (!this.status || isSlideMode) {
                transformStyle = "translate" + (this.position === 'left' || this.position === 'right' ? 'X' : 'Y');
                /** @type {?} */
                var isLeftOrTop = this.position === 'left' || this.position === 'top';
                /** @type {?} */
                var translateAmt = (isLeftOrTop ? '-' : '') + "100%";
                transformStyle += "(" + translateAmt + ")";
            }
            return (/** @type {?} */ (__assign({}, marginStyle, { webkitTransform: transformStyle, transform: transformStyle })));
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype.closeAnt = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this._anting = false;
                if (_this.status) {
                    _this._initCloseListeners();
                    _this.opened.emit();
                }
                else {
                    _this._destroyCloseListeners();
                    _this.closed.emit();
                }
            }), 300);
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype._initCloseListeners = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.status && this.backdrop) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    if (_this.backdrop && !_this._onClickOutsideAttached) {
                        _this.doc.addEventListener(_this._clickEvent, _this._onClickOutside, false);
                        _this._onClickOutsideAttached = true;
                    }
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype._destroyCloseListeners = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._onClickOutsideAttached) {
                this.doc.removeEventListener(this._clickEvent, this._onClickOutside, false);
                this._onClickOutsideAttached = false;
            }
        };
        /**
         * @private
         * @param {?} e
         * @return {?}
         */
        SidebarComponent.prototype._onClickOutside = /**
         * @private
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this._onClickOutsideAttached && this._elSidebar && !this._elSidebar.nativeElement.contains((/** @type {?} */ (e.target)))) {
                this.close();
            }
        };
        Object.defineProperty(SidebarComponent.prototype, "_height", {
            /** 获取侧边栏容器高度 */
            get: /**
             * 获取侧边栏容器高度
             * @return {?}
             */
            function () {
                return this._elSidebar.nativeElement ? this._elSidebar.nativeElement.offsetHeight : 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SidebarComponent.prototype, "_width", {
            /** 获取侧边栏容器宽度 */
            get: /**
             * 获取侧边栏容器宽度
             * @return {?}
             */
            function () {
                return this._elSidebar.nativeElement ? this._elSidebar.nativeElement.offsetWidth : 0;
            },
            enumerable: true,
            configurable: true
        });
        SidebarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-sidebar',
                        exportAs: 'weuiSidebar',
                        template: "<aside\n  #sidebar\n  role=\"complementary\"\n  [attr.aria-hidden]=\"!status\"\n  [attr.aria-label]=\"ariaLabel\"\n  class=\"weui-sidebar weui-sidebar__{{ status ? 'opened' : 'closed' }} weui-sidebar__{{ position }} weui-sidebar__{{\n    mode\n  }}\"\n  [class.weui-sidebar__inert]=\"!status\"\n  [ngClass]=\"sidebarClass\"\n  [ngStyle]=\"_getStyle()\"\n>\n  <ng-content></ng-content>\n</aside>\n",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        SidebarComponent.ctorParameters = function () { return [
            { type: SidebarService },
            { type: SidebarConfig },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        SidebarComponent.propDecorators = {
            status: [{ type: core.Input }],
            statusChange: [{ type: core.Output }],
            position: [{ type: core.Input }],
            mode: [{ type: core.Input }],
            backdrop: [{ type: core.Input }],
            sidebarClass: [{ type: core.Input }],
            ariaLabel: [{ type: core.Input }],
            openStart: [{ type: core.Output }],
            opened: [{ type: core.Output }],
            closeStart: [{ type: core.Output }],
            closed: [{ type: core.Output }],
            modeChange: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            _rerender: [{ type: core.Output }],
            _elSidebar: [{ type: core.ViewChild, args: ['sidebar',] }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], SidebarComponent.prototype, "status", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], SidebarComponent.prototype, "backdrop", void 0);
        return SidebarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 侧边栏容器
     */
    var SidebarContainerComponent = /** @class */ (function () {
        function SidebarContainerComponent(_ref, _el) {
            this._ref = _ref;
            this._el = _el;
            this._showBackdrop = false;
            this._showBackdropChange = new core.EventEmitter();
            this.orgOverflowX = '';
        }
        Object.defineProperty(SidebarContainerComponent.prototype, "body", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return (/** @type {?} */ (document.querySelector('body')));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._onToggle();
            this._subscribe();
            this._sidebars.changes.subscribe((/**
             * @return {?}
             */
            function () {
                _this._unsubscribe();
                _this._subscribe();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes._showBackdrop) {
                this._showBackdropChange.emit(changes._showBackdrop.currentValue);
            }
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.orgOverflowX = (/** @type {?} */ (this.body.style.overflowX));
            this.body.style.overflowX = 'hidden';
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._unsubscribe();
            this.body.style.overflowX = this.orgOverflowX;
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype._getStyles = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this._sidebars) {
                this._sidebars.forEach((/**
                 * @param {?} sidebar
                 * @return {?}
                 */
                function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    if (sidebar.mode === 'slide') {
                        /** @type {?} */
                        var transformStyle = null;
                        if (sidebar.status) {
                            /** @type {?} */
                            var isLeftOrTop = sidebar.position === 'left' || sidebar.position === 'top';
                            /** @type {?} */
                            var isLeftOrRight = sidebar.position === 'left' || sidebar.position === 'right';
                            /** @type {?} */
                            var transformDir = isLeftOrRight ? 'X' : 'Y';
                            /** @type {?} */
                            var transformAmt = "" + (isLeftOrTop ? '' : '-') + (isLeftOrRight ? sidebar._width : sidebar._height);
                            transformStyle = "translate" + transformDir + "(" + transformAmt + "px)";
                        }
                        _this._el.nativeElement.style.transform = transformStyle;
                    }
                }));
            }
            return (/** @type {?} */ ({
                margin: "0px 0px 0px 0px",
            }));
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        SidebarContainerComponent.prototype._onBackdropClicked = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            $event.preventDefault();
            $event.stopPropagation();
            this._sidebars.forEach((/**
             * @param {?} sidebar
             * @return {?}
             */
            function (sidebar) {
                if (sidebar.status && sidebar.backdrop) {
                    sidebar.close();
                }
            }));
            return false;
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._subscribe = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (this._sidebars) {
                this._sidebars.forEach((/**
                 * @param {?} sidebar
                 * @return {?}
                 */
                function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    sidebar.openStart.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._onToggle(); }));
                    sidebar.opened.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._markForCheck(); }));
                    sidebar.closeStart.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._onToggle(); }));
                    sidebar.closed.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._markForCheck(); }));
                    sidebar.modeChange.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._markForCheck(); }));
                    sidebar.positionChange.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._markForCheck(); }));
                    sidebar._rerender.subscribe((/**
                     * @return {?}
                     */
                    function () { return _this._markForCheck(); }));
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._unsubscribe = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._sidebars) {
                this._sidebars.forEach((/**
                 * @param {?} sidebar
                 * @return {?}
                 */
                function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    sidebar.openStart.unsubscribe();
                    sidebar.opened.unsubscribe();
                    sidebar.closeStart.unsubscribe();
                    sidebar.closed.unsubscribe();
                    sidebar.modeChange.unsubscribe();
                    sidebar.positionChange.unsubscribe();
                    sidebar._rerender.unsubscribe();
                }));
            }
        };
        /** 状态变更时重新计算样式 */
        /**
         * 状态变更时重新计算样式
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._markForCheck = /**
         * 状态变更时重新计算样式
         * @private
         * @return {?}
         */
        function () {
            this._ref.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._onToggle = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._sidebars) {
                /** @type {?} */
                var hasOpen = false;
                /** @type {?} */
                var _sidebars = this._sidebars.toArray();
                // tslint:disable-next-line: prefer-for-of
                for (var i = 0; i < _sidebars.length; i++) {
                    /** @type {?} */
                    var sidebar = _sidebars[i];
                    if (sidebar.status) {
                        hasOpen = true;
                        break;
                    }
                }
                this._showBackdrop = hasOpen;
                this._showBackdropChange.emit(hasOpen);
            }
            this._markForCheck();
        };
        SidebarContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-sidebar-container',
                        exportAs: 'weuiSidebarContainer',
                        template: "<ng-content select=\"weui-sidebar\"></ng-content>\n<div *ngIf=\"_showBackdrop\" aria-hidden=\"true\" class=\"weui-mask\" (click)=\"_onBackdropClicked($event)\"></div>\n<div class=\"weui-sidebar__content\" [ngStyle]=\"_getStyles()\">\n  <ng-content></ng-content>\n</div>\n",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        SidebarContainerComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef },
            { type: core.ElementRef }
        ]; };
        SidebarContainerComponent.propDecorators = {
            _sidebars: [{ type: core.ContentChildren, args: [SidebarComponent,] }],
            _showBackdrop: [{ type: core.Input }],
            _showBackdropChange: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], SidebarContainerComponent.prototype, "_showBackdrop", void 0);
        return SidebarContainerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 关闭侧边栏指令
     */
    var CloseSidebarDirective = /** @class */ (function () {
        function CloseSidebarDirective(_sidebarService) {
            this._sidebarService = _sidebarService;
        }
        /**
         * @return {?}
         */
        CloseSidebarDirective.prototype._onClick = /**
         * @return {?}
         */
        function () {
            this._sidebarService.close();
        };
        CloseSidebarDirective.decorators = [
            { type: core.Directive, args: [{ selector: '[closeSidebar]', exportAs: 'weuiCloseSidebar' },] }
        ];
        /** @nocollapse */
        CloseSidebarDirective.ctorParameters = function () { return [
            { type: SidebarService }
        ]; };
        CloseSidebarDirective.propDecorators = {
            _onClick: [{ type: core.HostListener, args: ['click',] }]
        };
        return CloseSidebarDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [SidebarContainerComponent, SidebarComponent, CloseSidebarDirective];
    var SidebarModule = /** @class */ (function () {
        function SidebarModule() {
        }
        SidebarModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: COMPONENTS,
                        exports: COMPONENTS,
                        providers: [SidebarService],
                    },] }
        ];
        return SidebarModule;
    }());

    exports.CloseSidebarDirective = CloseSidebarDirective;
    exports.SidebarComponent = SidebarComponent;
    exports.SidebarConfig = SidebarConfig;
    exports.SidebarContainerComponent = SidebarContainerComponent;
    exports.SidebarModule = SidebarModule;
    exports.SidebarService = SidebarService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-sidebar.umd.js.map
