/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/slider', ['exports', '@angular/core', '@angular/forms', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].slider = {}), global.ng.core, global.ng.forms, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, forms, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SliderComponent = /** @class */ (function () {
        function SliderComponent(el, cdr) {
            this.cdr = cdr;
            this.state = null;
            this.isInit = false;
            this.value = 0;
            /**
             * 允许的最小值，默认：`0`
             */
            this.min = 0;
            /**
             * 允许的最大值，默认：`100`
             */
            this.max = 100;
            /**
             * 步长，默认：`1`
             */
            this.step = 1;
            /**
             * 是否可用
             */
            this.enabled = true;
            this.showValue = true;
            /**
             * 值改变时触发
             */
            this.change = new core.EventEmitter();
            this.el = el.nativeElement;
        }
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this.isInit = true;
            this.trackEl = (/** @type {?} */ ((/** @type {?} */ (this.el.querySelector('.weui-slider__track')))));
            this.handlerEl = (/** @type {?} */ ((/** @type {?} */ (this.el.querySelector('.weui-slider__handler')))));
            this.onTouchStart = this.startHandle.bind(this);
            this.onTouchMove = this.moveHandle.bind(this);
            this.handlerEl.addEventListener('touchstart', this.onTouchStart, false);
            this.handlerEl.addEventListener('touchmove', this.onTouchMove, false);
        };
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.handlerEl.removeEventListener('touchstart', this.onTouchStart, false);
            this.handlerEl.removeEventListener('touchmove', this.onTouchMove, false);
        };
        /**
         * @private
         * @return {?}
         */
        SliderComponent.prototype.refresh = /**
         * @private
         * @return {?}
         */
        function () {
            this.state = {
                enabled: this.enabled,
                left: this.el.getBoundingClientRect().left,
                size: (/** @type {?} */ (((/** @type {?} */ ((/** @type {?} */ (this.el.querySelector('.weui-slider__inner')))))).offsetWidth)),
                percentage: [0, 0, 0],
                x: 0,
            };
            this.max = +this.max;
            this.min = +this.min;
            this.step = +this.step;
            this.setValue(this.value);
            this.layout();
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        SliderComponent.prototype.setValue = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this.max > this.min) {
                this.state.percentage = [
                    // tslint:disable-next-line: binary-expression-operand-order
                    (100 * (value - this.min)) / (this.max - this.min),
                    0,
                    (this.step * 100) / (this.max - this.min),
                ];
            }
            else {
                this.state.percentage = [0, 0, 100];
            }
        };
        /**
         * @private
         * @return {?}
         */
        SliderComponent.prototype.layout = /**
         * @private
         * @return {?}
         */
        function () {
            this.trackEl.style.width = this.state.percentage[0] + '%';
            this.handlerEl.style.left = this.state.percentage[0] + '%';
        };
        /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        SliderComponent.prototype.startHandle = /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (this.state === null)
                this.refresh();
            this.state.x = ($event.touches[0] || $event.changedTouches[0]).pageX;
        };
        /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        SliderComponent.prototype.moveHandle = /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (!this.state.enabled)
                return false;
            /** @type {?} */
            var pageX = ($event.touches[0] || $event.changedTouches[0]).pageX;
            /** @type {?} */
            var xDiff = pageX - this.state.x;
            if (xDiff >= 15 || xDiff <= 15) {
                this.state.percentage[0] = this.getPercentage(pageX);
                this.layout();
                this.calculateValue(this.state.percentage[0]);
            }
        };
        /**
         * @private
         * @param {?} pageX
         * @return {?}
         */
        SliderComponent.prototype.getPercentage = /**
         * @private
         * @param {?} pageX
         * @return {?}
         */
        function (pageX) {
            /** @type {?} */
            var distanceToSlide = pageX - this.state.left;
            /** @type {?} */
            var percentage = (distanceToSlide / this.state.size) * 100;
            percentage = Math.round(percentage / this.state.percentage[2]) * this.state.percentage[2];
            return Math.max(0, Math.min(100, percentage));
        };
        /**
         * @private
         * @param {?} percentage
         * @return {?}
         */
        SliderComponent.prototype.calculateValue = /**
         * @private
         * @param {?} percentage
         * @return {?}
         */
        function (percentage) {
            /** @type {?} */
            var rawValue = (percentage / 100) * (this.max - this.min);
            // adjustment = this.min
            /** @type {?} */
            var value = this.min + Math.round(rawValue / this.step) * this.step;
            if (value < this.min)
                value = this.min;
            else if (value > this.max)
                value = this.max;
            this.value = value;
            this.onChange(this.value);
            this.onTouched();
            this.change.emit(this.value);
        };
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (this.isInit)
                this.refresh();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        SliderComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value) {
                this.value = +value;
                this.refresh();
                this.calculateValue(this.state.percentage[0]);
            }
            this.cdr.detectChanges();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SliderComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SliderComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        SliderComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.enabled = !isDisabled;
        };
        SliderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-slider, [weui-slider]',
                        exportAs: 'weuiSlider',
                        template: "<div *ngIf=\"!showValue\" class=\"weui-slider__inner\">\n  <div class=\"weui-slider__track\"></div>\n  <div class=\"weui-slider__handler\"></div>\n</div>\n<ng-container *ngIf=\"showValue\">\n  <div class=\"weui-slider\">\n    <div class=\"weui-slider__inner\">\n      <div class=\"weui-slider__track\"></div>\n      <div class=\"weui-slider__handler\"></div>\n    </div>\n  </div>\n  <div class=\"weui-slider-box__value\">{{ value }}</div>\n</ng-container>\n",
                        host: {
                            '[class.weui-slider-box]': 'showValue',
                            '[class.weui-slider]': '!showValue',
                            '[class.weui-slider__disabled]': '!enabled',
                        },
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return SliderComponent; })),
                                multi: true,
                            },
                        ],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        SliderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef }
        ]; };
        SliderComponent.propDecorators = {
            min: [{ type: core.Input, args: ['weui-min',] }],
            max: [{ type: core.Input, args: ['weui-max',] }],
            step: [{ type: core.Input, args: ['weui-step',] }],
            enabled: [{ type: core.Input, args: ['weui-enabled',] }],
            showValue: [{ type: core.Input, args: ['weui-show-value',] }],
            change: [{ type: core.Output, args: ['weui-change',] }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], SliderComponent.prototype, "min", void 0);
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], SliderComponent.prototype, "max", void 0);
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], SliderComponent.prototype, "step", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], SliderComponent.prototype, "enabled", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], SliderComponent.prototype, "showValue", void 0);
        return SliderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SliderModule = /** @class */ (function () {
        function SliderModule() {
        }
        SliderModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [SliderComponent],
                        exports: [SliderComponent],
                    },] }
        ];
        return SliderModule;
    }());

    exports.SliderDirective = SliderComponent;
    exports.SliderModule = SliderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-slider.umd.js.map
