/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/swiper', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].swiper = {}), global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperConfig = /** @class */ (function () {
        function SwiperConfig() {
            /**
             * 等同于swiper[参数项](http://idangero.us/swiper/api/)
             */
            this.options = {
                loop: true,
                pagination: '.swiper-pagination',
            };
        }
        SwiperConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SwiperConfig.ngInjectableDef = core.defineInjectable({ factory: function SwiperConfig_Factory() { return new SwiperConfig(); }, token: SwiperConfig, providedIn: "root" });
        return SwiperConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperComponent = /** @class */ (function () {
        function SwiperComponent(el, zone, DEF) {
            this.el = el;
            this.zone = zone;
            this.DEF = DEF;
        }
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.initOptions = /**
         * @private
         * @return {?}
         */
        function () {
            this.options = __assign({}, this.DEF.options, this.options);
        };
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.init = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.destroy();
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            function () {
                _this.swiper = new Swiper(_this.containerEl, _this.options);
            }));
        };
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.destroy = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.containerEl) {
                ['horizontal', 'vertical'].forEach((/**
                 * @param {?} v
                 * @return {?}
                 */
                function (v) {
                    _this.containerEl.classList.remove('swiper-container-' + v);
                }));
            }
            if (this.swiper) {
                this.zone.runOutsideAngular((/**
                 * @return {?}
                 */
                function () {
                    _this.swiper.destroy(true, false);
                    _this.swiper = null;
                }));
            }
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.options)
                this.initOptions();
            this.containerEl = this.el.nativeElement.querySelector('.swiper-container');
            if (!this.containerEl)
                throw new Error('组件内容的HTML跟swiper所需要的DOM结构必须完全一样。');
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this.init();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        SwiperComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.options) {
                this.initOptions();
                if (!changes.options.firstChange) {
                    this.init();
                }
            }
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.destroy();
        };
        SwiperComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-swiper',
                        exportAs: 'weuiSwiper',
                        template: "\n    <ng-content></ng-content>\n  ",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        SwiperComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.NgZone },
            { type: SwiperConfig }
        ]; };
        SwiperComponent.propDecorators = {
            options: [{ type: core.Input }]
        };
        return SwiperComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperModule = /** @class */ (function () {
        function SwiperModule() {
        }
        SwiperModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [SwiperComponent],
                        exports: [SwiperComponent],
                    },] }
        ];
        return SwiperModule;
    }());

    exports.SwiperComponent = SwiperComponent;
    exports.SwiperConfig = SwiperConfig;
    exports.SwiperModule = SwiperModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-swiper.umd.js.map
