/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/tab', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].tab = {}), global.ng.core, global['ngx-weui'].core, global.ng.common, global.ng.forms));
}(this, function (exports, core, core$1, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarComponent = /** @class */ (function () {
        function BarComponent(cdr) {
            this.cdr = cdr;
            this.tabs = [];
        }
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.add = /**
         * @param {?} tab
         * @return {?}
         */
        function (tab) {
            this.tabs.push(tab);
            tab.active = this.tabs.length === 1 && tab.active !== false;
        };
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.remove = /**
         * @param {?} tab
         * @return {?}
         */
        function (tab) {
            /** @type {?} */
            var index = this.tabs.indexOf(tab);
            if (index === -1 || this.isDestroyed) {
                return;
            }
            // Select a new tab if the tab to be removed is selected and not destroyed
            if (tab.active && this.hasAvailableTabs(index)) {
                /** @type {?} */
                var newActiveIndex = this.getClosestTabIndex(index);
                this.tabs[newActiveIndex].active = true;
            }
            tab.removed.emit(tab);
            this.tabs.splice(index, 1);
        };
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.setActive = /**
         * @param {?} tab
         * @return {?}
         */
        function (tab) {
            tab.active = true;
            tab.select.emit(tab);
        };
        /**
         * @return {?}
         */
        BarComponent.prototype.detectChanges = /**
         * @return {?}
         */
        function () {
            this.cdr.detectChanges();
        };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BarComponent.prototype.getClosestTabIndex = /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        function (index) {
            /** @type {?} */
            var tabsLength = this.tabs.length;
            if (!tabsLength) {
                return -1;
            }
            for (var step = 1; step <= tabsLength; step += 1) {
                /** @type {?} */
                var prevIndex = index - step;
                /** @type {?} */
                var nextIndex = index + step;
                if (this.tabs[prevIndex] && !this.tabs[prevIndex].disabled) {
                    return prevIndex;
                }
                if (this.tabs[nextIndex] && !this.tabs[nextIndex].disabled) {
                    return nextIndex;
                }
            }
            return -1;
        };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BarComponent.prototype.hasAvailableTabs = /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        function (index) {
            /** @type {?} */
            var tabsLength = this.tabs.length;
            if (!tabsLength) {
                return false;
            }
            for (var i = 0; i < tabsLength; i += 1) {
                if (!this.tabs[i].disabled && i !== index) {
                    return true;
                }
            }
            return false;
        };
        /**
         * @return {?}
         */
        BarComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.isDestroyed = true;
        };
        BarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-bar-component',
                        template: ""
                    }] }
        ];
        /** @nocollapse */
        BarComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        return BarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TabDirective = /** @class */ (function () {
        function TabDirective(tab) {
            /**
             * 当tab激活时触发
             */
            this.select = new core.EventEmitter();
            /**
             * 当tab无效时触发
             */
            this.deselect = new core.EventEmitter();
            /**
             * 当tab移除时触发
             */
            this.removed = new core.EventEmitter();
            this._tabComp = tab;
            this._tabComp.add(this);
        }
        Object.defineProperty(TabDirective.prototype, "active", {
            /**
             * 激活
             */
            get: /**
             * 激活
             * @return {?}
             */
            function () {
                return this._active;
            },
            set: /**
             * @param {?} active
             * @return {?}
             */
            function (active) {
                var _this = this;
                if ((this.disabled && active) || !active) {
                    if (!active) {
                        this._active = active;
                    }
                    this.deselect.emit(this);
                    return;
                }
                this._active = active;
                this._tabComp.tabs.filter((/**
                 * @param {?} t
                 * @return {?}
                 */
                function (t) { return t !== _this; })).forEach((/**
                 * @param {?} tab
                 * @return {?}
                 */
                function (tab) { return (tab.active = false); }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TabDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (!this.activeIcon) {
                this.activeIcon = this.icon;
            }
            this._tabComp.detectChanges();
        };
        /**
         * @return {?}
         */
        TabDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._tabComp.remove(this);
        };
        TabDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'weui-tab, [weui-tab]',
                        exportAs: 'weuiTab',
                    },] }
        ];
        /** @nocollapse */
        TabDirective.ctorParameters = function () { return [
            { type: BarComponent }
        ]; };
        TabDirective.propDecorators = {
            heading: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            icon: [{ type: core.Input }],
            activeIcon: [{ type: core.Input }],
            badge: [{ type: core.Input }],
            select: [{ type: core.Output }],
            deselect: [{ type: core.Output }],
            removed: [{ type: core.Output }],
            active: [{ type: core.HostBinding, args: ['class.active',] }, { type: core.Input }]
        };
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean)
        ], TabDirective.prototype, "disabled", void 0);
        __decorate([
            core$1.InputBoolean(),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [Boolean])
        ], TabDirective.prototype, "active", null);
        return TabDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 顶部选项卡
     */
    var NavbarComponent = /** @class */ (function (_super) {
        __extends(NavbarComponent, _super);
        function NavbarComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NavbarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-navbar',
                        exportAs: 'weuiNavbar',
                        template: "<div class=\"weui-navbar\">\n  <div\n    class=\"weui-navbar__item\"\n    [ngClass]=\"{ 'weui-bar__item_on': item.active }\"\n    [class.disabled]=\"item.disabled\"\n    *ngFor=\"let item of tabs\"\n    (click)=\"setActive(item)\"\n  >\n    {{ item.heading }}\n  </div>\n</div>\n<div class=\"weui-tab__panel\"><ng-content></ng-content></div>\n",
                        providers: [{ provide: BarComponent, useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NavbarComponent; })) }],
                        host: {
                            '[class.weui-tab]': 'true',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        return NavbarComponent;
    }(BarComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 底部选项卡
     */
    var TabbarComponent = /** @class */ (function (_super) {
        __extends(TabbarComponent, _super);
        function TabbarComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TabbarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-tabbar',
                        exportAs: 'weuiTabbar',
                        template: "<div class=\"weui-tab__panel\"><ng-content></ng-content></div>\n<div class=\"weui-tabbar\">\n  <div\n    class=\"weui-tabbar__item\"\n    [ngClass]=\"{ 'weui-bar__item_on': item.active }\"\n    *ngFor=\"let item of tabs\"\n    (click)=\"setActive(item)\"\n  >\n    <div style=\"display: inline-block;position: relative;\">\n      <div class=\"weui-tabbar__icon\" [innerHTML]=\"item.active ? item.activeIcon : item.icon\"></div>\n      <span\n        class=\"weui-badge\"\n        style=\"position: absolute;top: -2px;right: -13px;\"\n        *ngIf=\"item.badge && item.badge !== 'dot'\"\n        >{{ item.badge }}</span\n      >\n      <span\n        class=\"weui-badge weui-badge_dot\"\n        style=\"position: absolute;top: 0;right: -6px;\"\n        *ngIf=\"item.badge && item.badge === 'dot'\"\n      ></span>\n    </div>\n    <p class=\"weui-tabbar__label\">{{ item.heading }}</p>\n  </div>\n</div>\n",
                        providers: [{ provide: BarComponent, useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return TabbarComponent; })) }],
                        host: {
                            '[class.weui-tab]': 'true',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        return TabbarComponent;
    }(BarComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [TabDirective, NavbarComponent, TabbarComponent, BarComponent];
    var TabModule = /** @class */ (function () {
        function TabModule() {
        }
        TabModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: COMPONENTS,
                        exports: COMPONENTS,
                    },] }
        ];
        return TabModule;
    }());

    exports.BarComponent = BarComponent;
    exports.NavbarComponent = NavbarComponent;
    exports.TabDirective = TabDirective;
    exports.TabModule = TabModule;
    exports.TabbarComponent = TabbarComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-tab.umd.js.map
