/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('ngx-weui/core')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/toast', ['exports', '@angular/common', '@angular/core', 'ngx-weui/core'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].toast = {}), global.ng.common, global.ng.core, global['ngx-weui'].core));
}(this, function (exports, common, core, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastConfig = /** @class */ (function () {
        function ToastConfig() {
            /**
             * 成功配置项
             */
            this.success = {
                text: '已完成',
                icon: 'weui-icon-success-no-circle',
                time: 2000,
            };
            /**
             * 加载中配置项
             */
            this.loading = {
                text: '加载中…',
                icon: 'weui-loading',
                time: 2000,
            };
        }
        ToastConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ ToastConfig.ngInjectableDef = core.defineInjectable({ factory: function ToastConfig_Factory() { return new ToastConfig(); }, token: ToastConfig, providedIn: "root" });
        return ToastConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastComponent = /** @class */ (function () {
        function ToastComponent(DEF) {
            this.DEF = DEF;
            /**
             * 显示时长后自动关闭（单位：ms），0 表示永久，默认：`2000`
             */
            this.time = 2000;
            /**
             * 隐藏后回调
             */
            this.hide = new core.EventEmitter();
            this._showd = false;
            this.type = 'success';
        }
        Object.defineProperty(ToastComponent.prototype, "type", {
            /**
             * 类型
             */
            set: /**
             * 类型
             * @param {?} _t
             * @return {?}
             */
            function (_t) {
                Object.assign(this, this.DEF[_t]);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        ToastComponent.prototype.onShow = /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () {
            var _this = this;
            (/** @type {?} */ (this))._showd = true;
            if ((/** @type {?} */ (this)).time > 0) {
                (/** @type {?} */ (this)).timer = setTimeout((/**
                 * @return {?}
                 */
                function () {
                    (/** @type {?} */ (_this)).onHide();
                }), (/** @type {?} */ (this)).time);
            }
            return (/** @type {?} */ (this));
        };
        /**
         * @return {?}
         */
        ToastComponent.prototype.onHide = /**
         * @return {?}
         */
        function () {
            this._showd = false;
            this.hide.emit();
        };
        /**
         * @return {?}
         */
        ToastComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.timer) {
                clearTimeout(this.timer);
                this.timer = null;
            }
        };
        ToastComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-toast',
                        exportAs: 'weuiToast',
                        template: "<div class=\"weui-mask_transparent\"></div>\n<div class=\"weui-toast\">\n  <i class=\"{{ icon }} weui-icon_toast\"></i>\n  <p class=\"weui-toast__content\">{{ text }}</p>\n</div>\n",
                        host: {
                            '[hidden]': '!_showd',
                        },
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ToastComponent.ctorParameters = function () { return [
            { type: ToastConfig }
        ]; };
        ToastComponent.propDecorators = {
            type: [{ type: core.Input }],
            text: [{ type: core.Input }],
            icon: [{ type: core.Input }],
            time: [{ type: core.Input }],
            hide: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], ToastComponent.prototype, "time", void 0);
        return ToastComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastService = /** @class */ (function (_super) {
        __extends(ToastService, _super);
        function ToastService(resolver, applicationRef, injector, doc) {
            return _super.call(this, resolver, applicationRef, injector, doc) || this;
        }
        /**
         * 构建toast并显示
         *
         * @param [text] 文本（可选）
         * @param [time] 显示时长后自动关闭（单位：ms），0 表示永久（可选）
         * @param [icon] icon图标Class名（可选）
         * @param [type] 类型（可选）
         */
        /**
         * 构建toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @param {?=} type
         * @return {?}
         */
        ToastService.prototype.show = /**
         * 构建toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @param {?=} type
         * @return {?}
         */
        function (text, time, icon, type) {
            /** @type {?} */
            var componentRef = this.build(ToastComponent);
            if (type)
                componentRef.instance.type = type;
            if (text)
                componentRef.instance.text = text;
            if (icon)
                componentRef.instance.icon = icon;
            if (typeof time === 'number')
                componentRef.instance.time = time;
            componentRef.instance.hide.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    componentRef.destroy();
                }), 300);
            }));
            return componentRef.instance.onShow();
        };
        /**
         * 关闭最新toast
         */
        /**
         * 关闭最新toast
         * @return {?}
         */
        ToastService.prototype.hide = /**
         * 关闭最新toast
         * @return {?}
         */
        function () {
            this.destroy();
        };
        /**
         * 构建成功toast并显示
         *
         * @param [text] 文本（可选）
         * @param [time] 显示时长后自动关闭（单位：ms）（可选）
         * @param [icon] icon图标Class名（可选）
         */
        /**
         * 构建成功toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @return {?}
         */
        ToastService.prototype.success = /**
         * 构建成功toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @return {?}
         */
        function (text, time, icon) {
            return this.show(text, time, icon, 'success');
        };
        /**
         * 构建加载中toast并显示
         *
         * @param [text] 文本（可选）
         * @param [time] 显示时长后自动关闭（单位：ms）（可选）
         * @param [icon] icon图标Class名（可选）
         */
        /**
         * 构建加载中toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @return {?}
         */
        ToastService.prototype.loading = /**
         * 构建加载中toast并显示
         *
         * @param {?=} text
         * @param {?=} time
         * @param {?=} icon
         * @return {?}
         */
        function (text, time, icon) {
            return this.show(text, time, icon, 'loading');
        };
        ToastService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        ToastService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        /** @nocollapse */ ToastService.ngInjectableDef = core.defineInjectable({ factory: function ToastService_Factory() { return new ToastService(core.inject(core.ComponentFactoryResolver), core.inject(core.ApplicationRef), core.inject(core.INJECTOR), core.inject(common.DOCUMENT)); }, token: ToastService, providedIn: "root" });
        return ToastService;
    }(core$1.BaseService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastModule = /** @class */ (function () {
        function ToastModule() {
        }
        ToastModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ToastComponent],
                        exports: [ToastComponent],
                        entryComponents: [ToastComponent],
                    },] }
        ];
        return ToastModule;
    }());

    exports.ToastComponent = ToastComponent;
    exports.ToastConfig = ToastConfig;
    exports.ToastModule = ToastModule;
    exports.ToastService = ToastService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-toast.umd.js.map
