/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/toptips', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].toptips = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToptipsComponent = /** @class */ (function () {
        function ToptipsComponent(el, uhcs) {
            this.el = el;
            this.uhcs = uhcs;
            this._showd = false;
            /**
             * 显示时长后自动关闭（单位：ms），默认：`2000`
             */
            this.time = 2000;
            /**
             * 类型
             */
            this.type = 'primary';
            /**
             * 隐藏后回调
             */
            this.hide = new core.EventEmitter();
        }
        /**
         * @private
         * @return {?}
         */
        ToptipsComponent.prototype.setClassMap = /**
         * @private
         * @return {?}
         */
        function () {
            var _a;
            /** @type {?} */
            var prefixCls = 'weui-toptips';
            var _b = this, uhcs = _b.uhcs, el = _b.el, type = _b.type;
            uhcs.updateHostClass(el.nativeElement, (_a = {},
                _a["" + prefixCls] = true,
                _a[prefixCls + "__" + type] = true,
                _a));
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.setClassMap();
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this.setClassMap();
        };
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        ToptipsComponent.prototype.onShow = /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () {
            var _this = this;
            (/** @type {?} */ (this)).destroy();
            (/** @type {?} */ (this))._showd = true;
            (/** @type {?} */ (this)).timer = setTimeout((/**
             * @return {?}
             */
            function () { return (/** @type {?} */ (_this)).onHide(); }), (/** @type {?} */ (this)).time);
            return (/** @type {?} */ (this));
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.onHide = /**
         * @return {?}
         */
        function () {
            this._showd = false;
            this.hide.emit();
        };
        /**
         * @private
         * @return {?}
         */
        ToptipsComponent.prototype.destroy = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.timer) {
                clearTimeout(this.timer);
                this.timer = null;
            }
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.destroy();
        };
        ToptipsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'weui-toptips',
                        exportAs: 'weuiToptips',
                        template: "\n    {{ text }}<ng-content></ng-content>\n  ",
                        host: {
                            '[hidden]': '!_showd',
                            '[style.display]': '_showd ? "block" : "none"',
                        },
                        providers: [core$1.UpdateHostClassService],
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ToptipsComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core$1.UpdateHostClassService }
        ]; };
        ToptipsComponent.propDecorators = {
            text: [{ type: core.Input }],
            time: [{ type: core.Input }],
            type: [{ type: core.Input }],
            hide: [{ type: core.Output }]
        };
        __decorate([
            core$1.InputNumber(),
            __metadata("design:type", Number)
        ], ToptipsComponent.prototype, "time", void 0);
        return ToptipsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToptipsService = /** @class */ (function (_super) {
        __extends(ToptipsService, _super);
        function ToptipsService(resolver, applicationRef, injector, doc) {
            return _super.call(this, resolver, applicationRef, injector, doc) || this;
        }
        /**
         * 构建一个Toptips并显示
         *
         * @param text 文本
         * @param type 类型
         * @param 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Toptips并显示
         *
         * @param {?} text 文本
         * @param {?} type 类型
         * @param {?=} time
         * @return {?}
         */
        ToptipsService.prototype.show = /**
         * 构建一个Toptips并显示
         *
         * @param {?} text 文本
         * @param {?} type 类型
         * @param {?=} time
         * @return {?}
         */
        function (text, type, time) {
            var _this = this;
            if (time === void 0) { time = 2000; }
            /** @type {?} */
            var componentRef = this.build(ToptipsComponent);
            if (type)
                componentRef.instance.type = type;
            if (text)
                componentRef.instance.text = text;
            componentRef.instance.time = time;
            componentRef.instance.hide.subscribe((/**
             * @return {?}
             */
            function () {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            return componentRef.instance.onShow();
        };
        /**
         * 构建一个Warn Toptips并显示
         *
         * @param text 文本
         * @param time 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Warn Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.warn = /**
         * 构建一个Warn Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'warn', time);
        };
        /**
         * 构建一个Info Toptips并显示
         *
         * @param text 文本
         * @param time 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Info Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.info = /**
         * 构建一个Info Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'info', time);
        };
        /**
         * 构建一个Primary Toptips并显示
         *
         * @param text 文本
         * @param time 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Primary Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.primary = /**
         * 构建一个Primary Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'primary', time);
        };
        /**
         * 构建一个Success Toptips并显示
         *
         * @param text 文本
         * @param time 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Success Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.success = /**
         * 构建一个Success Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'primary', time);
        };
        /**
         * 构建一个Default Toptips并显示
         *
         * @param text 文本
         * @param time 显示时长后自动关闭（单位：ms）
         */
        /**
         * 构建一个Default Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.default = /**
         * 构建一个Default Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'default', time);
        };
        ToptipsService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        ToptipsService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        /** @nocollapse */ ToptipsService.ngInjectableDef = core.defineInjectable({ factory: function ToptipsService_Factory() { return new ToptipsService(core.inject(core.ComponentFactoryResolver), core.inject(core.ApplicationRef), core.inject(core.INJECTOR), core.inject(common.DOCUMENT)); }, token: ToptipsService, providedIn: "root" });
        return ToptipsService;
    }(core$1.BaseService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToptipsModule = /** @class */ (function () {
        function ToptipsModule() {
        }
        ToptipsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [ToptipsComponent],
                        exports: [ToptipsComponent],
                        entryComponents: [ToptipsComponent],
                    },] }
        ];
        return ToptipsModule;
    }());

    exports.ToptipsComponent = ToptipsComponent;
    exports.ToptipsModule = ToptipsModule;
    exports.ToptipsService = ToptipsService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-toptips.umd.js.map
