/**
 * @license ngx-weui(cipchk@qq.com) v7.1.0-rc.2
 * (c) 2018 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/uploader', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].uploader = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, function (exports, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} node
     * @return {?}
     */
    function isElement(node) {
        return !!(node && (node.nodeName || (node.prop && node.attr && node.find)));
    }
    var FileLikeObject = /** @class */ (function () {
        function FileLikeObject(fileOrInput) {
            /** @type {?} */
            var isInput = isElement(fileOrInput);
            /** @type {?} */
            var fakePathOrObject = isInput ? fileOrInput.value : fileOrInput;
            /** @type {?} */
            var postfix = typeof fakePathOrObject === 'string' ? 'FakePath' : 'Object';
            /** @type {?} */
            var method = '_createFrom' + postfix;
            ((/** @type {?} */ (this)))[method](fakePathOrObject);
        }
        /**
         * @param {?} path
         * @return {?}
         */
        FileLikeObject.prototype._createFromFakePath = /**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            this.lastModifiedDate = void 0;
            this.size = void 0;
            this.type = 'like/' + path.slice(path.lastIndexOf('.') + 1).toLowerCase();
            this.name = path.slice(path.lastIndexOf('/') + path.lastIndexOf('\\') + 2);
        };
        /**
         * @param {?} object
         * @return {?}
         */
        FileLikeObject.prototype._createFromObject = /**
         * @param {?} object
         * @return {?}
         */
        function (object) {
            // this.lastModifiedDate = copy(object.lastModifiedDate);
            this.size = object.size;
            this.type = object.type;
            this.name = object.name;
        };
        return FileLikeObject;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文件对象
     */
    var   /**
     * 文件对象
     */
    FileItem = /** @class */ (function () {
        function FileItem(uploader, file, options) {
            /**
             * 索引
             */
            this.index = 0;
            /**
             * 上传进度
             */
            this.progress = 0;
            /**
             * 准备上传就绪
             */
            this.isReady = false;
            /**
             * 上传中
             */
            this.isUploading = false;
            /**
             * 已上传（不管错误与否都是true）
             */
            this.isUploaded = false;
            /**
             * 上传成功
             */
            this.isSuccess = false;
            /**
             * 用户取消上传
             */
            this.isCancel = false;
            /**
             * 上传失败
             */
            this.isError = false;
            this.uploader = uploader;
            this.setOptions(options);
            this.id = Math.random()
                .toString(36)
                .substring(7);
            this.file = new FileLikeObject(file);
            this._file = file;
        }
        /**
         * @param {?} options
         * @return {?}
         */
        FileItem.prototype.setOptions = /**
         * @param {?} options
         * @return {?}
         */
        function (options) {
            this.options = __assign({}, this.uploader.options, options);
        };
        /**
         * 上传
         */
        /**
         * 上传
         * @return {?}
         */
        FileItem.prototype.upload = /**
         * 上传
         * @return {?}
         */
        function () {
            try {
                this.uploader.uploadItem(this);
            }
            catch (e) {
                this.uploader._onCompleteItem(this, '', 0, {});
                this.uploader._onErrorItem(this, '', 0, {});
            }
        };
        /**
         * 取消上传
         */
        /**
         * 取消上传
         * @return {?}
         */
        FileItem.prototype.cancel = /**
         * 取消上传
         * @return {?}
         */
        function () {
            this.uploader.cancelItem(this);
        };
        /**
         * 从队列中移除，当文件正在上传中时会先取消
         */
        /**
         * 从队列中移除，当文件正在上传中时会先取消
         * @return {?}
         */
        FileItem.prototype.remove = /**
         * 从队列中移除，当文件正在上传中时会先取消
         * @return {?}
         */
        function () {
            this.uploader.removeFromQueue(this);
        };
        /**
         * @return {?}
         */
        FileItem.prototype._prepareToUploading = /**
         * @return {?}
         */
        function () {
            this.index = this.index || this.uploader._getNextIndex();
            this.isReady = true;
        };
        /**
         * @return {?}
         */
        FileItem.prototype._onBeforeUpload = /**
         * @return {?}
         */
        function () {
            this.isReady = true;
            this.isUploading = true;
            this.isUploaded = false;
            this.isSuccess = false;
            this.isCancel = false;
            this.isError = false;
            this.progress = 0;
            if (this.options.onUploadStart)
                this.options.onUploadStart(this);
        };
        /**
         * @param {?} progress
         * @return {?}
         */
        FileItem.prototype._onProgress = /**
         * @param {?} progress
         * @return {?}
         */
        function (progress) {
            this.progress = progress;
            if (this.options.onUploadProgress)
                this.options.onUploadProgress(this, progress, this.uploader.progress);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onSuccess = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = true;
            this.isSuccess = true;
            this.isCancel = false;
            this.isError = false;
            this.progress = 100;
            this.index = 0;
            if (this.options.onUploadSuccess)
                this.options.onUploadSuccess(this, response, status, headers);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onError = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = true;
            this.isSuccess = false;
            this.isCancel = false;
            this.isError = true;
            this.progress = 0;
            this.index = 0;
            if (this.options.onUploadError)
                this.options.onUploadError(this, response, status, headers);
        };
        /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        FileItem.prototype._onComplete = /**
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (response, status, headers) {
            if (this.uploader.options.removeAfterUpload) {
                this.remove();
            }
            if (this.options.onUploadComplete)
                this.options.onUploadComplete(this, response, status, headers);
        };
        /**
         * @return {?}
         */
        FileItem.prototype._onCancel = /**
         * @return {?}
         */
        function () {
            this.isReady = false;
            this.isUploading = false;
            this.isUploaded = false;
            this.isSuccess = false;
            this.isCancel = true;
            this.isError = false;
            this.progress = 0;
            this.index = 0;
            if (this.options.onUploadCancel)
                this.options.onUploadCancel(this);
        };
        return FileItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileType = /** @class */ (function () {
        function FileType() {
        }
        /**
         * @param {?} file
         * @return {?}
         */
        FileType.getMimeClass = /**
         * @param {?} file
         * @return {?}
         */
        function (file) {
            /** @type {?} */
            var mimeClass = 'application';
            if (this.mime_psd.indexOf(file.type) !== -1) {
                mimeClass = 'image';
            }
            else if (file.type.match('image.*')) {
                mimeClass = 'image';
            }
            else if (file.type.match('video.*')) {
                mimeClass = 'video';
            }
            else if (file.type.match('audio.*')) {
                mimeClass = 'audio';
            }
            else if (file.type === 'application/pdf') {
                mimeClass = 'pdf';
            }
            else if (this.mime_compress.indexOf(file.type) !== -1) {
                mimeClass = 'compress';
            }
            else if (this.mime_doc.indexOf(file.type) !== -1) {
                mimeClass = 'doc';
            }
            else if (this.mime_xsl.indexOf(file.type) !== -1) {
                mimeClass = 'xls';
            }
            else if (this.mime_ppt.indexOf(file.type) !== -1) {
                mimeClass = 'ppt';
            }
            if (mimeClass === 'application') {
                mimeClass = this.fileTypeDetection(file.name);
            }
            return mimeClass;
        };
        /**
         * @param {?} inputFilename
         * @return {?}
         */
        FileType.fileTypeDetection = /**
         * @param {?} inputFilename
         * @return {?}
         */
        function (inputFilename) {
            /** @type {?} */
            var types = {
                jpg: 'image',
                jpeg: 'image',
                tif: 'image',
                psd: 'image',
                bmp: 'image',
                png: 'image',
                nef: 'image',
                tiff: 'image',
                cr2: 'image',
                dwg: 'image',
                cdr: 'image',
                ai: 'image',
                indd: 'image',
                pin: 'image',
                cdp: 'image',
                skp: 'image',
                stp: 'image',
                '3dm': 'image',
                mp3: 'audio',
                wav: 'audio',
                wma: 'audio',
                mod: 'audio',
                m4a: 'audio',
                compress: 'compress',
                rar: 'compress',
                '7z': 'compress',
                lz: 'compress',
                z01: 'compress',
                pdf: 'pdf',
                xls: 'xls',
                xlsx: 'xls',
                ods: 'xls',
                mp4: 'video',
                avi: 'video',
                wmv: 'video',
                mpg: 'video',
                mts: 'video',
                flv: 'video',
                '3gp': 'video',
                vob: 'video',
                m4v: 'video',
                mpeg: 'video',
                m2ts: 'video',
                mov: 'video',
                doc: 'doc',
                docx: 'doc',
                eps: 'doc',
                txt: 'doc',
                odt: 'doc',
                rtf: 'doc',
                ppt: 'ppt',
                pptx: 'ppt',
                pps: 'ppt',
                ppsx: 'ppt',
                odp: 'ppt',
            };
            /** @type {?} */
            var chunks = inputFilename.split('.');
            if (chunks.length < 2) {
                return 'application';
            }
            /** @type {?} */
            var extension = chunks[chunks.length - 1].toLowerCase();
            if (types[extension] === undefined) {
                return 'application';
            }
            else {
                return types[extension];
            }
        };
        /*  MS office  */
        FileType.mime_doc = [
            'application/msword',
            'application/msword',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
            'application/vnd.ms-word.document.macroEnabled.12',
            'application/vnd.ms-word.template.macroEnabled.12',
        ];
        FileType.mime_xsl = [
            'application/vnd.ms-excel',
            'application/vnd.ms-excel',
            'application/vnd.ms-excel',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
            'application/vnd.ms-excel.sheet.macroEnabled.12',
            'application/vnd.ms-excel.template.macroEnabled.12',
            'application/vnd.ms-excel.addin.macroEnabled.12',
            'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
        ];
        FileType.mime_ppt = [
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.ms-powerpoint',
            'application/vnd.openxmlformats-officedocument.presentationml.presentation',
            'application/vnd.openxmlformats-officedocument.presentationml.template',
            'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
            'application/vnd.ms-powerpoint.addin.macroEnabled.12',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
            'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
        ];
        /* PSD */
        FileType.mime_psd = [
            'image/photoshop',
            'image/x-photoshop',
            'image/psd',
            'application/photoshop',
            'application/psd',
            'zz-application/zz-winassoc-psd',
        ];
        /* Compressed files */
        FileType.mime_compress = [
            'application/x-gtar',
            'application/x-gcompress',
            'application/compress',
            'application/x-tar',
            'application/x-rar-compressed',
            'application/octet-stream',
        ];
        return FileType;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderConfig = /** @class */ (function () {
        function UploaderConfig() {
            /**
             * 发送凭据，默认：`true`
             */
            this.withCredentials = true;
            /**
             * 是否自动上传，默认：`false`
             * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
             */
            this.auto = false;
            /**
             * 允许最多上传数量，-1 表示不受限，默认：`-1`
             */
            this.limit = -1;
            /**
             * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
             */
            this.size = -1;
        }
        UploaderConfig.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ UploaderConfig.ngInjectableDef = core.defineInjectable({ factory: function UploaderConfig_Factory() { return new UploaderConfig(); }, token: UploaderConfig, providedIn: "root" });
        return UploaderConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 内置HTML5上传组件
     */
    var Uploader = /** @class */ (function () {
        /**
         * Creates an instance of Uploader.
         */
        function Uploader(options, globalConfig) {
            this.globalConfig = globalConfig;
            this._queue = [];
            this._progress = 0;
            this._isUploading = false;
            this._nextIndex = 0;
            this.setOptions(options);
        }
        Object.defineProperty(Uploader.prototype, "options", {
            /**
             * 获取当前上传组件配置项
             */
            get: /**
             * 获取当前上传组件配置项
             * @return {?}
             */
            function () {
                return this._options;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "queue", {
            /**
             * 获取队列中所有文件对象
             */
            get: /**
             * 获取队列中所有文件对象
             * @return {?}
             */
            function () {
                return this._queue;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "progress", {
            /**
             * 获取当前总进度
             */
            get: /**
             * 获取当前总进度
             * @return {?}
             */
            function () {
                return this._progress;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "isUploading", {
            /**
             * 是否上传中
             */
            get: /**
             * 是否上传中
             * @return {?}
             */
            function () {
                return this._isUploading;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "notUploadedCount", {
            /**
             * 获取未上传数量
             */
            get: /**
             * 获取未上传数量
             * @return {?}
             */
            function () {
                return this.getNotUploadedItems().length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uploader.prototype, "uploadedCount", {
            /**
             * 获取已上传数量
             */
            get: /**
             * 获取已上传数量
             * @return {?}
             */
            function () {
                return this._queue.filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.isUploaded; })).length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        Uploader.prototype._getNextIndex = /**
         * @return {?}
         */
        function () {
            return ++this._nextIndex;
        };
        /**
         * 重置选项
         *
         * @param options
         * @param includeOldQueue 是否包括已存在队列中的文件
         */
        /**
         * 重置选项
         *
         * @param {?} options
         * @param {?=} includeOldQueue 是否包括已存在队列中的文件
         * @return {?}
         */
        Uploader.prototype.setOptions = /**
         * 重置选项
         *
         * @param {?} options
         * @param {?=} includeOldQueue 是否包括已存在队列中的文件
         * @return {?}
         */
        function (options, includeOldQueue) {
            if (includeOldQueue === void 0) { includeOldQueue = true; }
            this._options = (/** @type {?} */ (__assign({ filters: [], disableMultipart: false, method: 'POST', alias: 'file', withCredentials: true, auto: false, limit: -1, size: -1, removeAfterUpload: false }, this.globalConfig, this._options, options)));
            // 数量
            if (this._options.limit !== -1)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'queueLimit',
                    fn: this._queueLimitFilter,
                });
            // 大小
            if (this._options.size !== -1)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'fileSize',
                    fn: this._fileSizeFilter,
                });
            // 类型
            if (this._options.types)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'fileType',
                    fn: this._fileTypeFilter,
                });
            // mime类型
            if (this._options.mimes)
                (/** @type {?} */ (this._options.filters)).unshift({
                    name: 'mimeType',
                    fn: this._mimeTypeFilter,
                });
            // 对已经存在的队列重置所有配置信息
            if (includeOldQueue) {
                // tslint:disable-next-line: prefer-for-of
                for (var i = 0; i < this._queue.length; i++) {
                    this._queue[i].setOptions(this._options);
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        Uploader.prototype._queueLimitFilter = /**
         * @private
         * @return {?}
         */
        function () {
            return this._options.limit === undefined || this._queue.length < this._options.limit;
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._fileSizeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.size && (/** @type {?} */ (item)).size > this._options.size);
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._mimeTypeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.mimes && this._options.mimes.indexOf((/** @type {?} */ (item)).type) === -1);
        };
        /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        Uploader.prototype._fileTypeFilter = /**
         * @private
         * @param {?=} item
         * @param {?=} _options
         * @return {?}
         */
        function (item, _options) {
            return !(this._options.types && this._options.types.indexOf(FileType.getMimeClass((/** @type {?} */ (item)))) === -1);
        };
        /**
         * @private
         * @param {?} file
         * @param {?} filters
         * @param {?} options
         * @return {?}
         */
        Uploader.prototype._isValidFile = /**
         * @private
         * @param {?} file
         * @param {?} filters
         * @param {?} options
         * @return {?}
         */
        function (file, filters, options) {
            var _this = this;
            this._failFilterIndex = -1;
            return !filters.length
                ? true
                : filters.every((/**
                 * @param {?} filter
                 * @return {?}
                 */
                function (filter) {
                    _this._failFilterIndex++;
                    return filter.fn.call(_this, file, options);
                }));
        };
        /** 过滤器，如果未指定采用内置 */
        /**
         * 过滤器，如果未指定采用内置
         * @private
         * @param {?} filters
         * @return {?}
         */
        Uploader.prototype._getFilters = /**
         * 过滤器，如果未指定采用内置
         * @private
         * @param {?} filters
         * @return {?}
         */
        function (filters) {
            if (!filters)
                return (/** @type {?} */ (this._options.filters));
            if (Array.isArray(filters))
                return filters;
            if (typeof filters === 'string') {
                /** @type {?} */
                var names_1 = (/** @type {?} */ (filters.match(/[^\s,]+/g)));
                return (/** @type {?} */ (this._options.filters)).filter((/**
                 * @param {?} filter
                 * @return {?}
                 */
                function (filter) { return names_1.indexOf(filter.name) !== -1; }));
            }
            return (/** @type {?} */ (this._options.filters));
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype._getIndexOfItem = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return typeof value === 'number' ? value : this._queue.indexOf(value);
        };
        /** 获取未上传过列表 */
        /**
         * 获取未上传过列表
         * @private
         * @return {?}
         */
        Uploader.prototype.getNotUploadedItems = /**
         * 获取未上传过列表
         * @private
         * @return {?}
         */
        function () {
            return this._queue.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !item.isUploaded; }));
        };
        Object.defineProperty(Uploader.prototype, "getReadyItems", {
            /** 获取待上传文件 */
            get: /**
             * 获取待上传文件
             * @return {?}
             */
            function () {
                return this._queue
                    .filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.isReady && !item.isUploading; }))
                    .sort((/**
                 * @param {?} item1
                 * @param {?} item2
                 * @return {?}
                 */
                function (item1, item2) { return item1.index - item2.index; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * 将文件放入队列中
         *
         * @param files 文件列表
         * @param options 强制重新指定新 `options` 内容
         * @param filters 强制重新指定新 `filters` 内容
         */
        /**
         * 将文件放入队列中
         *
         * @param {?} files 文件列表
         * @param {?=} options 强制重新指定新 `options` 内容
         * @param {?=} filters 强制重新指定新 `filters` 内容
         * @return {?}
         */
        Uploader.prototype.addToQueue = /**
         * 将文件放入队列中
         *
         * @param {?} files 文件列表
         * @param {?=} options 强制重新指定新 `options` 内容
         * @param {?=} filters 强制重新指定新 `filters` 内容
         * @return {?}
         */
        function (files, options, filters) {
            var _this = this;
            var e_1, _a;
            /** @type {?} */
            var list = [];
            try {
                for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                    var file = files_1_1.value;
                    list.push(file);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            /** @type {?} */
            var arrayOfFilters = this._getFilters((/** @type {?} */ (filters)));
            /** @type {?} */
            var count = this._queue.length;
            if (!options) {
                options = this._options;
            }
            list.map((/**
             * @param {?} some
             * @return {?}
             */
            function (some) {
                /** @type {?} */
                var temp = new FileLikeObject(some);
                if (_this._isValidFile(temp, arrayOfFilters, (/** @type {?} */ (options)))) {
                    /** @type {?} */
                    var fileItem = new FileItem(_this, some, (/** @type {?} */ (options)));
                    _this._queue.push(fileItem);
                    if (_this._options.onFileQueued)
                        _this._options.onFileQueued(fileItem);
                }
                else {
                    /** @type {?} */
                    var filter = arrayOfFilters[_this._failFilterIndex];
                    if (_this._options.onError)
                        _this._options.onError(temp, filter, (/** @type {?} */ (options)));
                }
            }));
            if (this.queue.length !== count) {
                this._progress = this._getTotalProgress();
            }
            if ((/** @type {?} */ (this.options)).auto) {
                this.uploadAll();
            }
        };
        /**
         * 从队列中移除一个文件
         *
         * @param value FileItem对象或下标
         */
        /**
         * 从队列中移除一个文件
         *
         * @param {?} value FileItem对象或下标
         * @return {?}
         */
        Uploader.prototype.removeFromQueue = /**
         * 从队列中移除一个文件
         *
         * @param {?} value FileItem对象或下标
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            if (item.isUploading) {
                item.cancel();
            }
            this._queue.splice(index, 1);
            this._progress = this._getTotalProgress();
            if (this._options.onFileDequeued)
                this._options.onFileDequeued(item);
        };
        /**
         * 清空队列
         */
        /**
         * 清空队列
         * @return {?}
         */
        Uploader.prototype.clearQueue = /**
         * 清空队列
         * @return {?}
         */
        function () {
            while (this._queue.length) {
                this._queue[0].remove();
            }
            this._progress = 0;
            if (this._options.onFileDequeued)
                this._options.onFileDequeued();
        };
        /**
         * 上传某个文件
         */
        /**
         * 上传某个文件
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype.uploadItem = /**
         * 上传某个文件
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            item._prepareToUploading();
            if (this._isUploading) {
                return;
            }
            this._isUploading = true;
            this._xhrTransport(item);
        };
        /**
         * 取消某个文件
         */
        /**
         * 取消某个文件
         * @param {?} value
         * @return {?}
         */
        Uploader.prototype.cancelItem = /**
         * 取消某个文件
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var index = this._getIndexOfItem(value);
            /** @type {?} */
            var item = this._queue[index];
            if (item && item.isUploading) {
                if (item.options.abortTransport) {
                    this._onCancelItem(item);
                    this._onCompleteItem(item, (/** @type {?} */ (null)), (/** @type {?} */ (null)), (/** @type {?} */ (null)));
                    item.options.abortTransport(item);
                }
                else {
                    if (item._xhr)
                        item._xhr.abort();
                }
            }
        };
        /**
         * 上传队列中所有未上传的文件
         */
        /**
         * 上传队列中所有未上传的文件
         * @return {?}
         */
        Uploader.prototype.uploadAll = /**
         * 上传队列中所有未上传的文件
         * @return {?}
         */
        function () {
            /** @type {?} */
            var items = this.getNotUploadedItems().filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !item.isUploading; }));
            if (!items.length) {
                return;
            }
            items.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item._prepareToUploading(); }));
            if (this._options.onStart)
                this._options.onStart(items[0]);
            items[0].upload();
        };
        /**
         * 取消所有上传中文件
         */
        /**
         * 取消所有上传中文件
         * @return {?}
         */
        Uploader.prototype.cancelAll = /**
         * 取消所有上传中文件
         * @return {?}
         */
        function () {
            /** @type {?} */
            var items = this.getNotUploadedItems();
            items.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.cancel(); }));
            if (this._options.onCancel)
                this._options.onCancel();
        };
        /**
         * @return {?}
         */
        Uploader.prototype._destroy = /**
         * @return {?}
         */
        function () {
            return void 0;
        };
        /**
         * @private
         * @param {?} item
         * @return {?}
         */
        Uploader.prototype._xhrTransport = /**
         * @private
         * @param {?} item
         * @return {?}
         */
        function (item) {
            var _this = this;
            var e_2, _a;
            item._onBeforeUpload();
            // 自实现
            if (item.options.uploadTransport) {
                item.options.uploadTransport.apply(this, [item]).subscribe((/**
                 * @param {?} response
                 * @return {?}
                 */
                function (response) {
                    _this._onSuccessItem(item, response, 0, (/** @type {?} */ (null)));
                    _this._onCompleteItem(item, response, 0, (/** @type {?} */ (null)));
                }));
                return this;
            }
            /** @type {?} */
            var xhr = (item._xhr = new XMLHttpRequest());
            /** @type {?} */
            var sendable;
            if (typeof item._file.size !== 'number') {
                throw new TypeError('The file specified is no longer valid');
            }
            if (!this._options.disableMultipart) {
                sendable = new FormData();
                Object.keys(this._options.params || {}).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    return sendable.append(key, (/** @type {?} */ (_this._options.params))[key]);
                }));
                sendable.append(item.options.alias, item._file, item.file.name);
            }
            else {
                sendable = item._file;
            }
            xhr.upload.onprogress = (/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                /** @type {?} */
                var progress = Math.round(event.lengthComputable ? (event.loaded * 100) / event.total : 0);
                _this._onProgressItem(item, progress);
            });
            xhr.onload = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                /** @type {?} */
                var gist = _this._isSuccessCode(xhr.status) ? 'Success' : 'Error';
                /** @type {?} */
                var method = "_on" + gist + "Item";
                ((/** @type {?} */ (_this)))[method](item, response, xhr.status, headers);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.onerror = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                _this._onErrorItem(item, response, xhr.status, headers);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.onabort = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var headers = _this._parseHeaders(xhr.getAllResponseHeaders());
                /** @type {?} */
                var response = _this._transformResponse(xhr.response, headers);
                _this._onCancelItem(item);
                _this._onCompleteItem(item, response, xhr.status, headers);
            });
            xhr.open((/** @type {?} */ (item.options.method)), (/** @type {?} */ (item.options.url)), true);
            xhr.withCredentials = (/** @type {?} */ (item.options.withCredentials));
            if (item.options.headers && item.options.headers.length > 0) {
                try {
                    for (var _b = __values(item.options.headers), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var header = _c.value;
                        xhr.setRequestHeader(header.name, header.value);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            xhr.send(sendable);
            return this;
        };
        /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        Uploader.prototype._getTotalProgress = /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        function (value) {
            if (value === void 0) { value = 0; }
            if (this._options.removeAfterUpload) {
                return value;
            }
            /** @type {?} */
            var notUploaded = this.getNotUploadedItems().length;
            /** @type {?} */
            var uploaded = notUploaded ? this._queue.length - notUploaded : this._queue.length;
            /** @type {?} */
            var ratio = 100 / this._queue.length;
            /** @type {?} */
            var current = (value * ratio) / 100;
            return Math.round(uploaded * ratio + current);
        };
        /**
         * @private
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._parseHeaders = /**
         * @private
         * @param {?} headers
         * @return {?}
         */
        function (headers) {
            /** @type {?} */
            var parsed = {};
            /** @type {?} */
            var key;
            /** @type {?} */
            var val;
            /** @type {?} */
            var i;
            if (!headers) {
                return parsed;
            }
            headers.split('\n').map((/**
             * @param {?} line
             * @return {?}
             */
            function (line) {
                i = line.indexOf(':');
                key = line
                    .slice(0, i)
                    .trim()
                    .toLowerCase();
                val = line.slice(i + 1).trim();
                if (key) {
                    parsed[key] = parsed[key] ? parsed[key] + ", " + val : val;
                }
            }));
            return parsed;
        };
        /**
         * @private
         * @param {?} response
         * @param {?} _headers
         * @return {?}
         */
        Uploader.prototype._transformResponse = /**
         * @private
         * @param {?} response
         * @param {?} _headers
         * @return {?}
         */
        function (response, _headers) {
            return response;
        };
        /**
         * @private
         * @param {?} status
         * @return {?}
         */
        Uploader.prototype._isSuccessCode = /**
         * @private
         * @param {?} status
         * @return {?}
         */
        function (status) {
            return (status >= 200 && status < 300) || status === 304;
        };
        /**
         * @private
         * @param {?} item
         * @param {?} progress
         * @return {?}
         */
        Uploader.prototype._onProgressItem = /**
         * @private
         * @param {?} item
         * @param {?} progress
         * @return {?}
         */
        function (item, progress) {
            /** @type {?} */
            var total = this._getTotalProgress(progress);
            this._progress = total;
            item._onProgress(progress);
        };
        /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onErrorItem = /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onError(response, status, headers);
        };
        /**
         * @private
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onSuccessItem = /**
         * @private
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onSuccess(response, status, headers);
        };
        /**
         * @private
         * @param {?} item
         * @return {?}
         */
        Uploader.prototype._onCancelItem = /**
         * @private
         * @param {?} item
         * @return {?}
         */
        function (item) {
            item._onCancel();
        };
        /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        Uploader.prototype._onCompleteItem = /**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            item._onComplete(response, status, headers);
            /** @type {?} */
            var nextItem = this.getReadyItems[0];
            this._isUploading = false;
            if (nextItem) {
                nextItem.upload();
                return;
            }
            this._progress = this._getTotalProgress();
            if (this._options.onFinished)
                this._options.onFinished();
        };
        /** @nocollapse */
        Uploader.ctorParameters = function () { return [
            { type: undefined },
            { type: UploaderConfig, decorators: [{ type: core.Inject, args: [UploaderConfig,] }, { type: core.Optional }] }
        ]; };
        return Uploader;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderFileDirective = /** @class */ (function () {
        function UploaderFileDirective(element) {
            this.element = element;
        }
        Object.defineProperty(UploaderFileDirective.prototype, "_options", {
            get: /**
             * @return {?}
             */
            function () {
                return this.uploader.options;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UploaderFileDirective.prototype, "_isEmptyAfterSelection", {
            get: /**
             * @return {?}
             */
            function () {
                return !!this.element.nativeElement.attributes.multiple;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        UploaderFileDirective.prototype._onChange = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var files = this.element.nativeElement.files;
            this.uploader.addToQueue(files, this._options);
            if (this._isEmptyAfterSelection) {
                this.element.nativeElement.value = '';
            }
        };
        UploaderFileDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[weui-uploader-file]',
                        exportAs: 'weuiUploaderFile',
                    },] }
        ];
        /** @nocollapse */
        UploaderFileDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        UploaderFileDirective.propDecorators = {
            uploader: [{ type: core.Input, args: ['weui-uploader-file',] }],
            _onChange: [{ type: core.HostListener, args: ['change',] }]
        };
        return UploaderFileDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 创建缩略图
     */
    var FileThumbDirective = /** @class */ (function () {
        function FileThumbDirective(el) {
            this.el = el;
        }
        /**
         * @private
         * @return {?}
         */
        FileThumbDirective.prototype.render = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var url = core$1.genImageUrl(this.file);
            if (!url)
                return;
            this.el.nativeElement.style.backgroundImage = "url(" + url + ")";
        };
        /**
         * @return {?}
         */
        FileThumbDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        FileThumbDirective.decorators = [
            { type: core.Directive, args: [{ selector: '[weui-thumb]' },] }
        ];
        /** @nocollapse */
        FileThumbDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        FileThumbDirective.propDecorators = {
            file: [{ type: core.Input, args: ['weui-thumb',] }]
        };
        return FileThumbDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UploaderModule = /** @class */ (function () {
        function UploaderModule() {
        }
        UploaderModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [UploaderFileDirective, FileThumbDirective],
                        exports: [UploaderFileDirective, FileThumbDirective],
                    },] }
        ];
        return UploaderModule;
    }());

    exports.FileItem = FileItem;
    exports.FileLikeObject = FileLikeObject;
    exports.FileThumbDirective = FileThumbDirective;
    exports.FileType = FileType;
    exports.Uploader = Uploader;
    exports.UploaderConfig = UploaderConfig;
    exports.UploaderFileDirective = UploaderFileDirective;
    exports.UploaderModule = UploaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-weui-uploader.umd.js.map
