import { Directive, ElementRef, NgZone, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ChartG2Directive {
    /**
     * @param {?} el
     * @param {?} zone
     */
    constructor(el, zone) {
        this.el = el;
        this.zone = zone;
        this.initFlag = false;
    }
    /**
     * chart实例对象
     * @return {?}
     */
    get chart() {
        return this._chart;
    }
    /**
     * GM对象
     * @return {?}
     */
    get GM() {
        return GM;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.initFlag = true;
        this.buildChart();
    }
    /**
     * @private
     * @return {?}
     */
    buildChart() {
        /** @type {?} */
        const object = {
            el: this.el.nativeElement,
        };
        if (this.margin)
            object.margin = this.margin;
        this.zone.runOutsideAngular((/**
         * @return {?}
         */
        () => {
            this._chart = new GM.Chart(object);
        }));
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (this.initFlag && changes.margin && !changes.margin.firstChange) {
            this.buildChart();
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this._chart) {
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            () => {
                // fixed: TypeError: Cannot read property 'stop' of null
                try {
                    this._chart.destroy();
                }
                catch (e) {
                    console.warn(e);
                }
            }));
        }
    }
}
ChartG2Directive.decorators = [
    { type: Directive, args: [{ selector: 'canvas[weui-chart-g2]', exportAs: 'weuiChartG2' },] }
];
/** @nocollapse */
ChartG2Directive.ctorParameters = () => [
    { type: ElementRef },
    { type: NgZone }
];
ChartG2Directive.propDecorators = {
    margin: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ChartG2Module {
}
ChartG2Module.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [ChartG2Directive],
                exports: [ChartG2Directive],
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ChartG2Directive, ChartG2Module };
//# sourceMappingURL=ngx-weui-chart-g2.js.map
