import { Injectable, defineInjectable, inject, NgModule } from '@angular/core';
import { LoaderService } from 'ngx-weui/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class JWeiXinService {
    /**
     * @param {?} load
     */
    constructor(load) {
        this.load = load;
    }
    /**
     * 懒加载jweixin.js
     *
     * @param {?=} jweixinUrl 默认：//res.wx.qq.com/open/js/jweixin-1.2.0.js
     * @return {?}
     */
    get(jweixinUrl) {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        resolve => {
            this.load
                .loadScript(jweixinUrl || '//res.wx.qq.com/open/js/jweixin-1.2.0.js')
                .then((/**
             * @param {?} res
             * @return {?}
             */
            res => {
                resolve(res.loaded === true);
            }))
                .catch((/**
             * @return {?}
             */
            () => {
                resolve(false);
            }));
        }));
    }
}
JWeiXinService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
JWeiXinService.ctorParameters = () => [
    { type: LoaderService }
];
/** @nocollapse */ JWeiXinService.ngInjectableDef = defineInjectable({ factory: function JWeiXinService_Factory() { return new JWeiXinService(inject(LoaderService)); }, token: JWeiXinService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class JWeiXinModule {
}
JWeiXinModule.decorators = [
    { type: NgModule, args: [{},] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { JWeiXinModule, JWeiXinService };
//# sourceMappingURL=ngx-weui-jweixin.js.map
