import { defineInjectable, Injectable, Component, ChangeDetectionStrategy, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadmoreConfig = /** @class */ (function () {
    function LoadmoreConfig() {
        /**
         * 类型，默认：`loading`
         */
        this.type = 'loading';
        /**
         * 当type=='loading'时显示的文本，默认：`正在加载`
         */
        this.loadingText = '正在加载';
        /**
         * 当type=='line'时显示的文本，默认：`暂无数据`
         */
        this.lineText = '暂无数据';
    }
    LoadmoreConfig.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ LoadmoreConfig.ngInjectableDef = defineInjectable({ factory: function LoadmoreConfig_Factory() { return new LoadmoreConfig(); }, token: LoadmoreConfig, providedIn: "root" });
    return LoadmoreConfig;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadmoreComponent = /** @class */ (function () {
    function LoadmoreComponent(DEF) {
        /**
         * 类型，默认：`loading`
         */
        this.type = 'loading';
        /**
         * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
         */
        this.loadingText = '正在加载';
        /**
         * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
         */
        this.lineText = '暂无数据';
        Object.assign(this, DEF);
    }
    LoadmoreComponent.decorators = [
        { type: Component, args: [{
                    selector: 'weui-loadmore',
                    exportAs: 'weuiLoadmore',
                    template: "<div\n  class=\"weui-loadmore\"\n  [ngClass]=\"{\n    'weui-loadmore_line': type !== 'loading',\n    'weui-loadmore_dot': type === 'dot'\n  }\"\n>\n  <i class=\"weui-loading\" *ngIf=\"type === 'loading'\"></i>\n  <span class=\"weui-loadmore__tips\">{{ type === 'dot' ? '' : type === 'line' ? lineText : loadingText }}</span>\n</div>\n",
                    preserveWhitespaces: false,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    LoadmoreComponent.ctorParameters = function () { return [
        { type: LoadmoreConfig }
    ]; };
    LoadmoreComponent.propDecorators = {
        type: [{ type: Input }],
        loadingText: [{ type: Input }],
        lineText: [{ type: Input }]
    };
    return LoadmoreComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadmoreModule = /** @class */ (function () {
    function LoadmoreModule() {
    }
    LoadmoreModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [LoadmoreComponent],
                    exports: [LoadmoreComponent],
                    entryComponents: [LoadmoreComponent],
                },] }
    ];
    return LoadmoreModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LoadmoreComponent, LoadmoreConfig, LoadmoreModule };
//# sourceMappingURL=ngx-weui-loadmore.js.map
