import { ChangeDetectorRef, ElementRef, EventEmitter, OnInit } from '@angular/core';
import { PTRConfig } from './ptr.config';
export declare class PTRComponent implements OnInit {
    private el;
    private DEF;
    private cdr;
    private ogY;
    private loading;
    private touching;
    private touchId;
    private initScrollTop;
    private contentEl;
    _animating: boolean;
    _pullPercent: number;
    _lastLabel: string;
    private _config;
    config: PTRConfig;
    /** 是否禁止 */
    disabled: boolean;
    /** 下拉滚动时回调，返回一个0-100%的参数 */
    readonly scroll: EventEmitter<number>;
    /** 刷新回调 */
    readonly refresh: EventEmitter<PTRComponent>;
    constructor(el: ElementRef<HTMLElement>, DEF: PTRConfig, cdr: ChangeDetectorRef);
    /**
     * 设置最后更新标签
     *
     * @param label 标签内容（支持HTML）
     */
    setLastUpdatedLabel(label: string): void;
    /**
     * 设置刷新成功
     *
     * @param [lastUpdatedLabel] label 标签内容（支持HTML）
     */
    setFinished(lastUpdatedLabel?: string): void;
    onTouchStart($event: any): void;
    onTouchMove($event: any): void;
    onTouchEnd(): void;
    ngOnInit(): void;
}
